;dossys14/asm - kjw/bqsd - 08/72
;
	ORG	2200H		;High Overlay
;
	TITLE	'<DOS+ II.A - SYS14/SYS>'
;
ERROR	EQU	39		;display error
EVAL	EQU	83		;evaluate input command
OPEN	EQU	40		;open file/device
WILD	EQU	51		;wild card parser
SETBRK	EQU	3		;setup break processor
VIDKEY	EQU	12		;video/keyboard
VDCHAR	EQU	8		;char to video
;
SVC	EQU	08H		;execute SVC
DISKIO	EQU	10H		;direct disk I/O
OVLAY	EQU	18H		;execute overlay function
;
ERR01	EQU	01		;bad function code
ERR09	EQU	09		;invalid data
ERR25	EQU	25		;file access denied
ERR32	EQU	32		;invalid drivespec
ERR47	EQU	47		;required param not found
ERR48	EQU	48		;invalid param
ERR66	EQU	66		;no function exists
ERR72	EQU	72		;protected device
ERR85	EQU	85		;terminated
;
SREAD	EQU	06		;system sector read
SWRITE	EQU	07		;system sector write
;
BPASSW	EQU	0296H		;password '        '
LOCDCB	EQU	032AH		;load IX with DCB
LOCDCT	EQU	032DH		;load IY with DCT
BUFFER	EQU	1A00H		;I/O buffer
DIRRED	EQU	0324H		;LFN read
DIRWRT	EQU	0327H		;LFN write
UCASE	EQU	031EH		;char to upper case
;
;	$PROT	- change file/gat attributes
;	$ATTRIB	- change file attributes
;	$KILL	- delete file/device
;
	PAGE
;
VECTORS	DEFW	RETURN		;0 - nil
	DEFW	PROT		;1
	DEFW	ATTRIB		;2
	DEFW	KILL		;3
	DEFW	UNDEF		;4 - undefined
	DEFW	UNDEF		;5
	DEFW	UNDEF		;6
	DEFW	UNDEF		;7
	DEFW	UNDEF		;8
	DEFW	UNDEF		;9
	DEFW	UNDEF		;10
	DEFW	UNDEF		;11
	DEFW	UNDEF		;12
	DEFW	UNDEF		;13
	DEFW	UNDEF		;14
	DEFW	UNDEF		;15
;
UNDEF	LD	A,ERR01		;bad function call
	OR	A		;return NZ
	RET			;back to caller
;
;	exit vectors
;
ABORT	LD	A,ERR85		;program terminated
;
POSTE	AND	7FH		;assure a return
	LD	B,A		;pass to B
POSTEB	LD	A,ERROR		;error SVC #
	RST	SVC		;display error
;
EXIT	LD	HL,0		;restore old break
OLDBRK	EQU	$-2
	LD	A,SETBRK	;SVC #
	RST	SVC		;restore it
	LD	SP,0		;reset stack pointer
STACK	EQU	$-2
RETURN	XOR	A		;return zero
	RET			;back to caller
;
	PAGE
;
;	$PROT - change gat/file attributes
;
;	(P)W	- current master password (for LOCK)
;	(M)PW	- new master password
;	(L)OCK	- assign/remove passwords to files
;	(U)PD	- affect update password only
;	(A)CC	- affect access password only
;	(N)AME	- change diskette name
;	(D)ATE	- change diskette date
;	(C)LEAN	- erase unused entries
;	(I)NV	- assign attribute to files
;
PROT	LD	(STACK),SP	;save stack pointer
	CALL	SETUP		;clear params
;
;	set UPD and ACC as true
;
	LD	A,-1		;FF (true)
	LD	(UPDPAR),A	;save param
	LD	(ACCPAR),A	;save param
	LD	(UPDFLAG),A	;flag for sector update
;
;	set LOCK/INV to neither on/off
;
	LD	A,80H		;non 00/FF
	LD	(LOCPAR),A
;
;	initialize eval block
;
	LD	DE,PROTPAR	;param block
	LD	(EBLOCK+7),DE	;save it
	LD	IX,EBLOCK	;prot eval block
	LD	A,EVAL		;SVC #
	RST	SVC		;evaluate input
	JR	NZ,POSTE	;error, abort!
;
	LD	A,(IX)		;get user input
	AND	6		;any input fields?
	LD	A,0		;default to system drive
	JR	Z,PROTCNT	;continue, have drive
;
	LD	A,(DCB)		;get flag byte
	LD	B,ERR48		;invalid parameter
	BIT	7,A		;device here?
	JR	Z,POSTEB	;nope, go!
	BIT	6,A		;filespec?
	JR	NZ,POSTEB	;yep, go!
	AND	0FH		;low 4 bits only
	SUB	8		;adjust 8-15 => 0-7
	LD	B,ERR66		;no function
	JR	C,POSTEB	;can't prot low devices
;
PROTCNT	LD	(DRIVE),A	;save drive number
	LD	C,A		;save here
	CALL	LOCDCT		;find the DCT
	CALL	RDGAT		;read the GAT table
	LD	DE,(BUFFER+0CEH)	;get master pass
	LD	(MASTER),DE	;save it for lock
;
;	set flags on if gat/files need updating
;
	OR	-1		;NZ for update flag
	EX	AF,AF'		;save in alt
;
;	check for name change
;
CHKNAM	LD	HL,(NAMPAR)	;get param
	LD	A,H		;anything?
	OR	L
	JR	Z,CHKDAT	;nope, check for date
	LD	DE,BUFFER+0D0H	;where it goes
	CALL	MOVSTR		;move in the string
	XOR	A		;set update flag
	EX	AF,AF'		;save it
;
;	check for date change
;
CHKDAT	LD	HL,(DATPAR)	;get param
	LD	A,H		;anything?
	OR	L
	JR	Z,CHKMPW	;check for master pw chng
;
	LD	DE,BUFFER+0D8H	;where it goes
	CALL	MOVSTR		;move it in!
	XOR	A		;set update flag
	EX	AF,AF'		;save in alt
;
;	check for new master password
;
CHKMPW	LD	HL,(MPWPAR)	;get param
	LD	A,H		;anything?
	OR	L
	JR	Z,CHKGPUT	;nope, check attributes
;
	CALL	CKMAST		;old must be specified
	LD	DE,DCB		;re-use DCB
	PUSH	DE		;save pointer
	CALL	MOVSTR		;move it in!
	POP	DE		;DE => new password
	CALL	CODE		;code it!
	LD	(BUFFER+0CEH),HL	;put into GAT
	LD	(MASTER),HL	;save new master
	XOR	A		;setup update flag
	EX	AF,AF'		;save in alt
;
;	check for gat table update
;
CHKGPUT	EX	AF,AF'		;get flag
	CALL	Z,WRGAT		;write back the gat
;
;	check if any file action to be taken
;
	LD	A,(LOCPAR)	;any LOCK/UNLOCK?
	INC	A		;yes?
	JR	Z,CHKFILE	;yes, go!
	DEC	A		;no?
	JR	Z,CHKFILE	;yes, go!
	LD	A,(CLEPAR)	;clean?
	INC	A		;yes?
	JR	NZ,EXITA	;nope, go!
;
;	set subroutine vector
;
CHKFILE	LD	HL,PROTV	;subroutine vector
	LD	(SUBR),HL	;save vector
;
;	if LOCK specified, password must be valid
;
	LD	A,(LOCPAR)	;get lock param
	INC	A		;lock=yes?
	JR	Z,CHKPASS	;yes, check password
	DEC	A		;lock=no?
	JR	NZ,LOOPFIL	;nope, loop through files
;
;	check disk master password with user entry
;
CHKPASS	CALL	CKMAST		;check master password
;
;	setup loop to read all dir sectors
;
LOOPFIL	LD	B,(IY+18)	;get directory length
	DEC	B		;less GAT
	DEC	B		;less HIT
	LD	E,2		;first sector to read
;
NEXFIL	LD	HL,BUFFER	;I/O buffer
	CALL	RSYSTEM		;read system sector
;
PROTLP	LD	A,E		;get sector
	DEC	A		;less HIT
	DEC	A		;A = relative sector
	OR	L		;L = relative byte
	LD	(DEC),A		;save DEC for file
;
	PUSH	HL		;save pointer
	EXX			;use alt set
	POP	IX		;IX => current file
	CALL	0		;call sub vector
SUBR	EQU	$-2
	EXX			;get pointers/counter
	LD	A,L		;get current sector
	ADD	A,20H		;next entry
	LD	L,A		;put it back
	JR	NZ,PROTLP	;finish this sector
;
;	write back current sector
;
	LD	A,(UPDFLAG)	;get update flag
	INC	A		;true?
	CALL	Z,WSYSTEM	;write system sector
;
;	bump current sector
;
	INC	E		;point to next sector
	DEC	B		;less sector counter
	JR	NZ,NEXFIL	;go next sector
EXITA	JP	EXIT		;else done!
;
;	execute PROT fields
;	HL => current file
;
PROTV	LD	A,(IX)		;get flag byte
	BIT	4,A		;active entry?
	JR	Z,PROTREM	;check for 'clean'
	AND	0C0H		;system or extension?
	RET	NZ		;don't do 'em
;
;	check for password changes
;
	LD	A,(LOCPAR)	;get LOCK param
	INC	A		;lock=yes?
	JR	Z,PROLCK	;yes, assign MPW
	DEC	A		;lock=no?
	RET	NZ		;neither, return!
;
;	remove passwords
;
	LD	A,(IX)		;fetch attribute byte
	AND	0F8H		;remove low 3 bits
	LD	(IX),A		;put it back
	LD	(IX+10H),96H
	LD	(IX+11H),22H
	LD	(IX+12H),96H
	RET			;passwords removed
;
;	assign master password
;
PROLCK	LD	HL,(MASTER)	;get master password
	LD	A,(ACCPAR)	;get access param
	INC	A		;yes?
	JR	NZ,CKUPD	;nope, check update
;
	CALL	INSACC		;insert ACCESS password
;
CKUPD	LD	A,(UPDPAR)	;get update param
	INC	A		;to be done?
	RET	NZ		;nope, done with file
;
	JP	INSUPD		;insert update password
;
;	check for 'clean' param
;
PROTREM	LD	A,(CLEPAR)	;get param
	INC	A		;yes?
	RET	NZ		;nope skip
;
	PUSH	IX		;pass to DE
	POP	DE		;DE => entry
	LD	B,20H		;length of entry
	JR	FILL		;fill with zeroes
;
;	check for valid master password
;
CKMAST	PUSH	HL		;save it
	LD	HL,(PWPAR)	;get user param
	LD	A,H		;anything?
	OR	L
	JR	NZ,MASTHER	;master is specified
	LD	HL,BPASSW	;blank password
	JR	MASTHAV		;have password
MASTHER	LD	DE,DCB		;re-use DCB
	PUSH	DE		;save it
	CALL	MOVSTR		;move user string here
	POP	DE		;restore pointer
	CALL	CODE		;code the password
MASTHAV	LD	DE,0196H	;system password
	OR	A		;clear carry
	SBC	HL,DE		;master specified?
	JR	Z,MASTOK	;yes, override!
	ADD	HL,DE		;put it back
	LD	DE,(MASTER)	;get master pass
	LD	A,D		;get MSB
	AND	0FH		;remove low 4, clear C
	LD	D,A		;DE = 12 bit password
	SBC	HL,DE		;give the right one?
	LD	A,ERR25		;access denied
	JP	NZ,POSTE	;error!
MASTOK	POP	HL		;restore it
	RET			;else OK, return
;
;	move string from HL => DE, pad with spaces
;
MOVSTRU	XOR	A		;NOP opcode
	JR	MOVSTRV		;continue
;
MOVSTR	LD	A,0C9H		;RET opcode
MOVSTRV	LD	(UCONV),A	;upper case caller
	LD	BC,0808H	;B=max, C=counter
;
MOVSLP	LD	A,(HL)		;fetch a character
	CP	'"'		;string terminator?
	JR	Z,MOVSDN	;yes, go!
	CP	27H		;single quote?
	JR	Z,MOVSDN	;yes, go!
;
	CP	13
	JR	Z,MOVSDN	;check for terminators
	CP	3
	JR	Z,MOVSDN
;
	CALL	UCONV		;convert?
	LD	(DE),A		;put into dest
	INC	HL		;bump pointers
	INC	DE
	DEC	C		;bump count
	DJNZ	MOVSLP		;finish it off
	RET			;done!
;
MOVSDN	INC	C		;check for done
	DEC	C		;all 8 done?
	RET	Z		;yes, done
	LD	A,' '		;pad with space
	LD	B,C		;remainder count
;
;	fill subroutine
;
FILL	LD	(DE),A		;insert character
	INC	DE		;bump pointer
	DJNZ	FILL		;do for length
	RET			;done
;
UCONV	NOP			;intercepted here
	JP	UCASE		;make it upper case
;
;	setup params for lib command
;
SETUP	LD	B,28		;param data length
	LD	DE,DATA		;data table start
	XOR	A		;fill with zeroes
	CALL	FILL		;clear it
	PUSH	HL		;save input pointer
	LD	HL,0		;turn off break processor
	LD	A,SETBRK	;SVC #
	RST	SVC		;do it
	LD	(OLDBRK),HL	;save old vector
	POP	HL		;restore input pointer
	RET			;done
;
;	read in GAT table
;
RDGAT	LD	E,0		;sector zero
	LD	HL,BUFFER	;read it here
;
RSYSTEM	PUSH	BC		;save
	LD	A,(DRIVE)	;fetch drive
	LD	C,A		;pass here
	LD	B,0		;extended sector
	LD	A,SREAD		;system read
	RST	DISKIO		;read it!
	JP	NZ,POSTE	;error, abort!
	POP	BC
	RET			;else return OK
;
;	write gat table
;
WRGAT	LD	E,0		;sector zero
	LD	HL,BUFFER	;data is here
;
WSYSTEM	PUSH	BC		;save
	LD	A,(DRIVE)	;fetch drive
	LD	C,A		;pass here
	LD	B,0		;extended sector
	LD	A,SWRITE	;system write
	RST	DISKIO		;write it out
	JP	NZ,POSTE	;error!
	POP	BC		;restore
	RET			;done, sector written
;
;	code password
;
CODE	LD	A,2-1<4+3	;sys 2, #3
	RST	OVLAY		;fetch password
;
PURGE	LD	A,3-1<4+3	;sys 3, #3
	RST	OVLAY		;kill logical file
;
EBLOCK	DEFB	0		;flags
	DEFW	DCB		;source
	DEFW	DCB		;dest
	DEFW	DCB		;mask (unused)
	DEFW	0		;param block
;
EBLOCKK	DEFB	0
	DEFW	DCB
	DEFW	DCB
	DEFW	MDCB
	DEFW	KILLPAR
;
PROTPAR	DEFB	80H+1		;string + length-1
	DEFW	PWPAR		;param vector
	DEFM	'PW'		;param word
;
	DEFB	80H+2
	DEFW	MPWPAR
	DEFM	'MPW'
;
	DEFB	20H+3		;switch
	DEFW	LOCPAR
	DEFM	'LOCK'
;
	DEFB	20H+2
	DEFW	UPDPAR
	DEFM	'UPD'
;
	DEFB	20H+2
	DEFW	ACCPAR
	DEFM	'ACC'
;
	DEFB	80H+3		;string
	DEFW	NAMPAR
	DEFM	'NAME'
;
	DEFB	80H+3
	DEFW	DATPAR
	DEFM	'DATE'
;
	DEFB	20H+4		;switch
	DEFW	CLEPAR
	DEFM	'CLEAN'
;
	DEFB	0
;
;	attrib param block
;
ATTPAR	DEFB	80H+2
	DEFW	ACCPAR
	DEFM	'ACC'
;
	DEFB	80H+2
	DEFW	UPDPAR
	DEFM	'UPD'
;
	DEFB	40H+3
	DEFW	PROPAR
	DEFM	'PROT'
;
	DEFB	20H+2
	DEFW	INVPAR
	DEFM	'INV'
;
	DEFB	20H+3
	DEFW	KEEPAR
	DEFM	'KEEP'
;
	DEFB	20H+2
	DEFW	MODPAR
	DEFM	'MOD'
;
	DEFB	80H+1
	DEFW	PWPAR
	DEFM	'PW'
;
	DEFB	0
;
;	parm list for KILL
;
KILLPAR	DEFB	20H+4
	DEFW	QUEPAR
	DEFM	'QUERY'
;
	DEFB	20H+2
	DEFW	CLEPAR
	DEFM	'INV'
;
	DEFB	20H+2
	DEFW	ERAPAR
	DEFM	'SYS'
;
	DEFB	80H+1
	DEFW	PWPAR
	DEFM	'PW'
;
	DEFB	20H+3
	DEFW	ECHPAR
	DEFM	'ECHO'
;
	DEFB	0
;
;	param data table
;
DATA	EQU	$
ACCPAR	DEFW	0		;access password
UPDPAR	DEFW	0		;update password
PROPAR	DEFW	0		;protection level
INVPAR	DEFW	0		;visible/invisible
KEEPAR	DEFW	0		;non-shrinkable
MODPAR	DEFW	0		;mod flags
PWPAR	DEFW	0		;passwords
QUEPAR	DEFW	0		;query
CLEPAR	DEFW	0		;clean
ERAPAR	DEFW	0		;erase
MPWPAR	DEFW	0		;new master password
LOCPAR	DEFW	0		;lock
NAMPAR	DEFW	0		;diskette name
DATPAR	DEFW	0		;diskette date
ECHPAR	DEFW	0		;echo
;
DCB	DEFS	41		;for DCB
MDCB	EQU	BUFFER		;use I/O buffer!
DRIVE	DEFB	0		;drive number
DEC	DEFB	0		;logical file number
MASTER	DEFW	0		;master password
FLAG	DEFB	0		;system flag
UPDFLAG	DEFB	0		;update sector on COMMON
;
OLIST	DEFW	BUFFER
	DEFW	BUFFER
	DEFW	0
	DEFB	'W'
	DEFB	0
	DEFB	'E'
	DEFB	3		;open, new LRL
	DEFB	0		;terminator
;
	PAGE
;
;	$ATTRIB - change file attributes
;
;	ATTRIB wildmask/filespec, params, ...
;
;	(A)CC	= new access password
;	(U)PD	= new update password
;	(P)ROT	= new protection level
;	(I)NV	= switch
;	(K)EEP	= set non-shrinkable file
;	(M)OD	= set/clear mod flag
;
ATTRIB	LD	(STACK),SP	;save stack pointer
	CALL	SETUP		;setup params
	LD	A,80H		;set NOT true/false
	LD	(PROPAR),A	;prot level
	LD	(INVPAR),A	;invisible
	LD	(KEEPAR),A	;keep
	LD	(MODPAR),A	;mod
;
	LD	A,-1		;set update flag
	LD	(UPDFLAG),A	;save it
	LD	DE,ATTPAR	;attrib params
	LD	(EBLOCKK+7),DE	;save into table
	LD	IX,EBLOCKK	;eval data block
	LD	A,EVAL		;SVC #
	RST	SVC		;fetch user params
	JP	NZ,POSTE	;param error!
;
;	code passwords if supplied
;
	LD	HL,(ACCPAR)	;get access password
	LD	A,H		;anything?
	OR	L
	JR	Z,SETUPD	;nil, check updte
	CALL	GETPASS		;compute password
	LD	(ACCESS),HL	;save it
;
SETUPD	LD	HL,(UPDPAR)	;get update password
	LD	A,H		;anything?
	OR	L
	JR	Z,SETCNT	;continue
	CALL	GETPASS		;compute password
	LD	(UPDATE),HL	;save it
;
;	setup vectors
;
SETCNT	LD	HL,ATTRIBV	;attrib vector
	LD	A,(IX)		;get flags
	AND	7		;low 3 bits only
	LD	B,ERR47		;required parameter
	JP	Z,POSTEB	;error!
	BIT	0,A		;wild mask here?
	LD	BC,ATTRIB1	;single file attrib
	JR	NZ,ATTWLD	;setup for wild
;
;	check out parameters
;
	LD	DE,DCB		;point to DCB
	LD	A,(DE)		;get type flag
	BIT	6,A		;filespec/wildmask here?
	LD	A,ERR48		;invalid parameter
	JP	Z,POSTE		;error!
	JP	COMMON		;go common vector
;
ATTWLD	LD	DE,MDCB		;mask DCB
	JP	COMMON		;go!
;
	PAGE
;
;	$KILL	- delete file/device
;
;	KILL wildmask/filespec/devicespec, param, ...
;
;	(Q)UERY	- prompt for kill
;	(C)LEAN	- erase entire entry on kill
;	(E)RASE	- erase file data
;	(P)W	- disk master password on wildmask kill
;	(E)CHO	- list files being killed
;
KILL	LD	(STACK),SP	;save stack pointer
	CALL	SETUP		;setup params
;
	LD	A,80H		;setup nil query prompt
	LD	(QUEPAR),A	;set up special
	LD	(ECHPAR),A	;echo param
	XOR	A		;set false update flag
	LD	(UPDFLAG),A	;save it
	LD	DE,KILLPAR	;kill params
	LD	(EBLOCKK+7),DE	;save into table
	LD	IX,EBLOCKK	;eval block
	LD	A,EVAL		;SVC #
	RST	SVC		;evaluate input params
	JP	NZ,POSTE	;error, go!
;
	LD	A,(IX)		;get user input
	AND	7		;anything?
	LD	B,ERR47		;required not found
	JP	Z,POSTEB	;nothing to kill
;
;	setup subroutine vectors
;
	LD	HL,KILLV	;kill vector
	LD	BC,KILL1	;single file kill
;
	BIT	0,A		;mask here?
	JR	NZ,KILLM	;yes, go!
;
	LD	DE,DCB		;point to input
	LD	A,(DE)		;fetch flag type
	BIT	6,A		;filespec here?
	JP	NZ,COMMON	;go common if yes
	JR	KILDV		;else kill device
;
;	check for mask kill
;
KILLM	LD	DE,MDCB		;mask DCB
	JP	COMMON		;kill common
;
;	kill a device
;
KILDV	AND	0FH		;get device number
	CP	8		;kill low device?
	JR	C,KILLOW	;yes, go!
	LD	B,ERR72		;protected device
	JP	Z,POSTEB	;can't kill drive zero
	SUB	8		;adjust to 0-7
	LD	C,A		;pass drive number
	CALL	LOCDCT		;find the DCT
	SET	3,(IY)		;turn it off!
	JP	EXIT		;done, return zero
;
KILLOW	CALL	LOCDCB		;find the DCB
	SET	3,(IX)		;turn it off!
	JP	EXIT		;done, return zero
;
;	common vector for KILL/ATTRIB
;
COMMON	LD	(SUBR),HL	;save sub vector
	LD	(SUBR1),BC	;single action
	LD	A,(DE)		;fetch type flag
	BIT	5,A		;wildmask here?
	JR	NZ,COMWILD	;yes, go looper!
;
;	single file affected
;
	INC	DE		;normal DCB
	LD	HL,OLIST	;file open param list
	LD	A,OPEN		;SVC #
	RST	SVC		;open the file
	JP	NZ,POSTE	;error, display why!
;
;	attrib/kill single file, DE => open DCB
;
ATTKILL	PUSH	DE		;pass to IX
	POP	IX
	LD	A,(IX+16)	;get drive number
	LD	(DRIVE),A	;save it
	LD	C,A		;need it here
	LD	A,(IX+17)	;get DEC of file
	LD	(DEC),A		;save it
	LD	B,A		;need in B for read
	CALL	DIRRED		;read it
	JP	NZ,POSTE	;error, go!
	PUSH	BC		;save drive/LFN
	LD	DE,MDCB		;save dir record here
	PUSH	DE		;for pass to IX
	LD	BC,32		;record length
	LDIR			;save it
	POP	IX		;IX => record
	CALL	0		;call subroutine
SUBR1	EQU	$-2
;
	POP	BC		;BC = LFN
	LD	A,(UPDFLAG)	;write sector back?
	INC	A		;true?
	JP	NZ,EXIT		;nope, done!
	CALL	DIRRED		;reload sys buffer
	JP	NZ,POSTE	;error this time
;
	PUSH	BC		;save drive/LFN again
	EX	DE,HL		;DE => where it goes
	LD	HL,MDCB		;stored data
	LD	BC,32		;length
	LDIR			;move it back
	POP	BC		;restore LFN/drive
	CALL	DIRWRT		;write it!
	JP	NZ,POSTE	;error, go!
	JP	EXIT		;done, leave program
;
;	wildmask involved, setup loop through directory
;
COMWILD	EX	DE,HL		;HL => user mask
	INC	HL		;text area of mask
	LD	B,0		;command
	LD	A,WILD		;SVC #
	RST	SVC		;set wildcard mask
	JP	NZ,POSTE	;error, why?
;
	LD	A,(DCB)		;get DCB flags
	BIT	7,A		;device here?
	LD	C,0		;default drive 0
	JR	Z,COMM1		;no drive, use zero
	AND	0FH		;get drive number
	SUB	8		;adjust for actual
	LD	B,ERR32		;invalid drive
	JP	C,POSTE		;go error
	LD	C,A		;pass to C
COMM1	LD	A,C		;get drive
	LD	(DRIVE),A	;save it
	CALL	LOCDCT		;find the DCT
	CALL	RDGAT		;read the GAT table
	LD	HL,(BUFFER+0CEH)	;get master PW
	LD	(MASTER),HL	;save it
	CALL	CKMAST		;valid?
;
;	force QUERY on wildmask kills
;
	LD	A,(QUEPAR)	;get param
	CP	80H		;nil?
	JP	NZ,LOOPFIL	;nope, use input
	LD	A,-1		;else set true
	LD	(QUEPAR),A	;turn query on
	JP	LOOPFIL		;go common looper
;
;	subroutine vector for ATTRIB
;
ATTRIBV	BIT	4,(IX)		;active file?
	RET	Z		;nope, return
	BIT	7,(IX)		;extension?
	RET	NZ		;yep, return
	BIT	6,(IX)		;system file
	RET	NZ		;yes, don't do it
	CALL	MATCH		;wild card match?
	RET	NZ		;nope, skip this file
;
;	correct file, IX => file entry
;
ATTRIB1	LD	HL,(ACCPAR)	;access password?
	LD	A,H		;anything?
	OR	L
	JR	Z,CKAUPD	;nope, check update
	CALL	PUTACC		;put ACCESS into entry
;
CKAUPD	LD	HL,(UPDPAR)	;update password?
	LD	A,H		;any bits on?
	OR	L
	JR	Z,CKAINV	;check vis/invis
	CALL	PUTUPD		;put UPDATE into entry
;
CKAINV	LD	A,(INVPAR)	;invis param
	INC	A		;set invis?
	JR	Z,ATTINV	;yes, set it
	DEC	A		;set vis?
	JR	NZ,CKAKEE	;nope, check keep
;
ATTVIS	RES	3,(IX)		;set visible
	JR	CKAKEE		;continue
;
ATTINV	SET	3,(IX)		;set invisible
;
CKAKEE	LD	A,(KEEPAR)	;keep ?
	INC	A		;yes?
	JR	Z,ATTKEY	;keep yes
	DEC	A		;no?
	JR	NZ,CKAMOD	;neither, check mod
;
ATTKEN	RES	5,(IX)		;set keep NO
	JR	CKAMOD		;continue
;
ATTKEY	SET	5,(IX)		;set keep YES
;
CKAMOD	LD	A,(MODPAR)	;get mod param
	INC	A		;yes?
	JR	Z,ATTMDY	;yes, go!
	DEC	A		;no?
	JR	NZ,CKAPRO	;neither, check prot
;
ATTMDN	RES	6,(IX+1)	;mod = NO
	JR	CKAPRO		;continue
;
ATTMDY	SET	6,(IX+1)	;mod = YES
;
CKAPRO	LD	A,(PROPAR)	;prot param
	BIT	7,A		;anything?
	RET	NZ		;nope, done!
	CP	8		;valid range?
	LD	B,ERR09		;invalid data
	JP	NC,POSTEB	;go error!
	LD	B,A		;save it
	LD	A,(IX)		;get current level
	AND	0F8H		;remove low 3 bits
	OR	B		;merge with new level
	LD	(IX),A		;put it back
	RET			;next file!
;
	PAGE
;
;	subroutine for KILL, IX => directory record
;
KILLV	BIT	4,(IX)		;already dead?
	RET	Z		;yes, skip it!
	BIT	7,(IX)		;extension?
	RET	NZ		;yes, skip it
	LD	A,(DEC)		;get DEC of file
	OR	A		;BOOT/SYS
	RET	Z		;yes, return
	DEC	A		;DIR/SYS?
	RET	Z		;don't kill it!
	CALL	MATCH		;check for a match
	RET	NZ		;nope, skip this file
;
;	kill single file, IX => dir record
;
	BIT	6,(IX)		;system file?
	JR	Z,KILL01	;nope, continue
	LD	A,(ERAPAR)	;system to include?
	INC	A		;yes?
	RET	NZ		;nope, return
	JR	KILL1		;else go!
;
KILL01	BIT	3,(IX)		;invisible file?
	JR	Z,KILL1		;nope, continue
	LD	A,(CLEPAR)	;get param
	INC	A		;invis to include?
	RET	NZ		;nope, go!
;
KILL1	CALL	QUERY		;query for kill?
	RET	C		;nope, don't kill it
;
;	kill the file
;
	LD	A,(DEC)		;get DEC of file
	LD	B,A		;pass here
	LD	A,(DRIVE)	;get drive
	LD	C,A		;pass here
	CALL	PURGE		;use SYS3 to kill it
;
;	if query on, display that file was killed
;
	LD	A,(QUEPAR)	;query param
	INC	A		;on?
	CALL	Z,SHOKIL	;display purged
;
;	completed
;
	RET			;done
;
;	check if current file matches wildmask
;
MATCH	PUSH	IX		;pass to HL
	POP	HL
	LD	A,L		;get LSB
	ADD	A,5		;offset to name
	LD	L,A		;HL => filename
	LD	B,3		;command
	LD	A,WILD		;SVC #
	RST	SVC		;compare to wildmask
	RET			;return Z = match
;
;	compute password
;
GETPASS	LD	DE,BUFFER	;use buffer area
	PUSH	DE		;save it
	CALL	MOVSTRU		;move and convert ucase
	POP	DE		;DE => password
	JP	CODE		;code it
;
;	insert UPDATE password into file entry
;
PUTUPD	LD	HL,0		;get update password
UPDATE	EQU	$-2
;
;	insert UPDATE password into file entry
;
INSUPD	LD	(IX+10H),L	;put LSB
	LD	A,(IX+11H)	;get MSB
	AND	0FH		;low 4 bits saved only
	LD	(IX+11H),A	;put it back
	LD	A,H		;fetch MSB password
	RLCA			;align to top 4 bits
	RLCA
	RLCA
	RLCA
	AND	0F0H		;top 4 only
	OR	(IX+11H)	;merge password
	LD	(IX+11H),A	;insert merged password
	RET			;done, password installed
;
;	insert ACCESS password
;
PUTACC	LD	HL,0		;get access password
ACCESS	EQU	$-2
;
;	insert ACCESS password
;
INSACC	LD	(IX+12H),L	;put LSB password
	LD	A,H		;fetch MSB
	AND	0FH		;low 4 bits only
	LD	H,A		;re-save it
	LD	A,(IX+11H)	;fetch existing password
	AND	0F0H		;top 4 bits only
	OR	H		;merge with new
	LD	(IX+11H),A	;update it
	RET			;done, on to next file
;
	PAGE
;
;	query to kill a file
;
QUERY	PUSH	IX		;pass to HL
	POP	HL		;HL => dir entry
	LD	A,L		;get LSB
	ADD	A,5		;offset to name
	LD	L,A		;HL => filename
	LD	DE,DCB		;re-use DCB
	LD	B,2		;command
	LD	A,WILD		;SVC #
	RST	SVC		;create filename
	JP	NZ,POSTE	;error!
	EX	DE,HL		;HL => filename
;
	LD	A,(QUEPAR)	;query?
	INC	A		;yes?
	JR	NZ,QUECHO	;check for echo
;
	CALL	LINE$		;display filename
;
	LD	HL,QUEMSG	;query message
	LD	BC,QUEMSGL<8+1	;length + key input len
	LD	DE,DCB		;for key input
	LD	A,VIDKEY	;display/keyboard
	RST	SVC		;display/fetch key
	JP	NZ,POSTE	;error, go!
	JP	C,ABORT		;break abort!
;
	LD	A,(DE)		;get first char
	CALL	UCASE		;make it upper
	CP	'Y'		;kill yes?
	RET	Z		;yes, kill!
	CP	'N'		;no kill?
	JR	NZ,QUERY	;neither, try again
	SCF			;return C for no kill
	RET			;return and kill it
;
QUECHO	LD	A,(ECHPAR)	;get echo param
	INC	A		;echo yes?
	JR	NZ,QUENO	;nope
	CALL	LINE$		;display filename
	LD	A,13		;term with CR
	CALL	DSP$		;display it
QUENO	XOR	A		;return NC
	RET			;done
;
SHOKIL	LD	HL,KILMSG	;deleted message
	JR	LINE$		;display it
;
KILMSG	DEFB	11		;up a line
	DEFW	0909H		;tab
	DEFW	0909H		;at position 32
	DEFM	'* Deleted *'
	DEFB	13		;carriage return
	DEFB	3		;terminator
;
QUEMSG	DEFB	13		;cursor to next row
	DEFB	11		;up beginning of row
	DEFB	9		;tab 8
	DEFB	9		;tab 16
	DEFM	'Delete ? '
QUEMSGL	EQU	$-QUEMSG
;
;	display text to video
;
LINE$	LD	A,(HL)		;get character
	CP	3		;end of text?
	RET	Z		;yes, done!
	CALL	DSP$		;display char
	INC	HL		;bump pointer
	JR	LINE$		;go next char
;
DSP$	PUSH	BC		;save it
	LD	B,A		;pass char
	LD	A,VDCHAR	;SVC #
	RST	SVC		;display char
	POP	BC
	RET	Z		;return no error
	JP	POSTE		;else abort
;
ZZZZZ	EQU	$
;
	END	VECTORS
