; dossys16/asm - kjw/bqsd - 07/82
;
	TITLE	'<DosPLUS II.A - SYS16/SYS>'
;
;	system is high residing @ 2200H and has:
;
;		$SYSTEM	- set system params
;		$CONFIG	- set drive params
;
	PAGE
;
;	support
;
PAGE1	EQU	01		;device table page
DATAK6	EQU	0171H		;low memory
DATAK5	EQU	016FH		;sys1 input pointer
LOMEM	EQU	DATAK6		;low free memory
DATAK7	EQU	0173H		;top memory
HIMEM	EQU	DATAK7		;top free memory
DATAK8	EQU	0175H		;top physical
PHYMEM	EQU	DATAK8		;top physical memory
KDCB	EQU	0339H		;@KI DCB address
DCB	EQU	1A00H		;run DCB area
OVLYH	EQU	0190H		;high overlay in memory
LOCDCT	EQU	032DH		;locate DCT into IY
;
DREAD	EQU	3		;read disk sector
DWRITE	EQU	5		;write disk sector
BADF	EQU	1		;bad function call
SLOTALV	EQU	6		;slot for 'alive'
ALVTASK	EQU	008CH		;vector for alive
SLOTTRC	EQU	5		;slot for 'trace'
TRCTASK	EQU	008AH		;vector for trace
;
VDCHAR	EQU	8		;char to video
BINHEX	EQU	24		;binary => hex conversion
ERROR	EQU	39		;display error
PARAM	EQU	87		;fetch params
NMICTL	EQU	92		;add/kill NMI vector
FSPEC	EQU	84		;fetch filespec
FEXT	EQU	88		;place default extension
OPEN	EQU	40		;open a file
CLOSE	EQU	42		;close a file
VDLINE	EQU	9		;line to video
PUT	EQU	78		;output to device
FDRV	EQU	89		;fetch drive spec
;
SVC	EQU	08H		;execute SVC
DISKIO	EQU	10H		;execute disk I/O
OVLY	EQU	18H		;load overlay
;
ERR98	EQU	98		;data out of range
;
;
	PAGE
;
	ORG	2200H		;high overlay
;
VECTORS	DW	RETURN		;0 - nil
	DW	SYSTEM		;1 - set system
	DW	CONFIG		;2 - set config
	DW	SHOWDRV		;3 - display drive type
	DW	UNDEF		;4 - undefinded
	DW	UNDEF		;5
	DW	UNDEF		;6
	DW	UNDEF		;7
	DW	UNDEF		;8
	DW	UNDEF		;9
	DW	UNDEF		;10
	DW	UNDEF		;11
	DW	UNDEF		;12
	DW	UNDEF		;13
	DW	UNDEF		;14
	DW	UNDEF		;15
;
;
;	undefined vector
;
UNDEF	LD	A,BADF		;bad function call
	OR	A		;set NZ
	RET			;back to caller
;
;
EXIT	AND	7FH		;force a return
	LD	B,A		;pass error
EXITB	LD	A,ERROR		;SVC #
	RST	SVC		;display error
RETURN	XOR	A		;force ZERO
	RET			;back to caller
;
	PAGE
;
;	$SYSTEM - set system parameters
;
;	SYSTEM,param,param,...'
;
;	params:
;
;	(B)reak  = switch	- break recognition
;	(A)live  = switch	- background display
;	 Trace   = switch	- background PC display
;
;	(L)omem  = value	- sets low memory
;	(H)imem  = value	- sets high memory
;
;	(S)ave   ="filespec"	- save settings to file
;
;	(D)ate   = switch	- bootup prompts
;	(T)ime   = switch	- bootup prompts
;	 Logo    = switch	- bootup logo display
;
;	SYSTEM	- displays current settings
;
	PAGE
;
SYSTEM	CALL	POSHL		;get a char
	JR	NZ,NOTSHOS	;input, fetch it
;
;	display settings
;
SHOWSYS	LD	DE,(LOMEM)	;get low memory
	LD	HL,SYSMSG4	;where it goes
	LD	A,BINHEX	;SVC #
	LD	B,0		;flag
	RST	SVC		;move it it
;
	LD	B,A		;A = 0
	LD	DE,(HIMEM)	;get high memory
	LD	HL,SYSMSG5	;where it goes
	LD	A,BINHEX
	RST	SVC
;
	LD	B,A		;A = 0
	LD	DE,(PHYMEM)	;get physical memory
	LD	HL,SYSMSG6
	LD	A,BINHEX
	RST	SVC
;
	LD	HL,SYSMSG	;text string
	LD	BC,SYSMSGL<8+13	;length + terminator
	LD	A,VDLINE	;line to display
	RST	SVC		;display it
;
SYSRET	LD	HL,KEYBUFF	;sys1 keyboard buffer
	LD	(HL),13		;terminate command
	LD	(DATAK5),HL	;save pointer
	JP	NZ,EXIT		;post error
;
	XOR	A		;force ZERO return
	RET			;else done
;
	PAGE
;
;	have input, evaluate it
;
NOTSHOS	PUSH	HL		;save pointer
	CALL	CLRDATA		;clear out data area
	LD	HL,0		;must set SAVE special
	LD	(SAVPAR),HL
	LD	(HIMPAR),HL	;these too
	LD	(LOMPAR),HL
	POP	HL		;restore pointer
;
	LD	DE,SPARM	;system parameters
	LD	A,PARAM		;SVC #
	RST	SVC		;fetch parameters
	JR	NZ,SYSRET	;error, exit
;
;	check BREAK param
;
	LD	HL,KDCB+5	;keyboard flag
	LD	A,(BRKPAR)	;parameter vector
	INC	A		;FF, yes
	JR	Z,BRKON		;yes, go
;
	DEC	A		;00, no
	JR	NZ,CKALV	;nope, skip it
;
BRKOFF	SET	6,(HL)		;turn it off
	JR	CKALV		;continue
;
BRKON	RES	6,(HL)		;turn it on
;
;	check for ALIVE
;
CKALV	LD	A,(ALVPAR)	;alive param
	INC	A		;FF?
	JR	Z,ALVON		;yes, go
;
	DEC	A		;00?
	JR	NZ,CKTRC	;nope, go!
;
ALVOFF	LD	B,0		;for remove
	JR	ALVSET		;go common
;
ALVON	LD	B,-1		;for add
;
ALVSET	LD	A,NMICTL	;NMI SVC#
	LD	C,SLOTALV	;slot for alive
	LD	DE,(ALVTASK)	;interrupt services
	RST	SVC		;add/remove it
;
;	check for TRACE
;
CKTRC	LD	A,(TRCPAR)	;trace param
	INC	A		;FF?
	JR	Z,TRCON		;yes, go
;
	DEC	A		;00?
	JR	NZ,CKLOM	;nope, continue
;
TRCOFF	LD	B,0		;setup for remove
	JR	TRCSET		;set it
;
TRCON	LD	B,-1		;setup for add
;
TRCSET	LD	A,NMICTL	;SVC #
	LD	C,SLOTTRC	;slot # for trace
	LD	DE,(TRCTASK)	;address for code
	RST	SVC		;add/remove it
;
;	check for low memory set
;
CKLOM	LD	DE,(LOMPAR)	;get parameter
	LD	A,D		;anything entered?
	OR	E
	JR	Z,CKHIM		;nope, check high memory
;
;	check for <2800H (illegal)
;
	LD	A,D		;get MSB
	CP	28H		;less?
	LD	A,ERR98		;invalid data
	JP	C,SYSRET	;error, can it!
;
;	check for > topmem (illegal)
;
	LD	HL,(HIMEM)	;get topmem
	SBC	HL,DE		;compare
	JP	C,SYSRET		;illegal!
;
HIOK1	LD	(LOMEM),DE	;else set low memory
;
;
;	check for high memory
;
CKHIM	LD	DE,(HIMPAR)	;get parameter
	LD	A,D		;anything input?
	OR	E
	JR	Z,CKSAV		;nope, check for save
;
;	check for less than low memory
;
	LD	HL,(LOMEM)	;get lowmem
	SBC	HL,DE		;compare
	LD	A,ERR98		;illegal data range
	JP	NC,SYSRET	;error, exit
;
;	check for greater than current himem
;
	LD	HL,(HIMEM)	;get it
	OR	A		;clear carry
	SBC	HL,DE		;compare
	JP	C,SYSRET	;forget it
;
;
	LD	(HIMEM),DE	;put in new value
;
;	check for saving into a file
;
CKSAV	LD	HL,(SAVPAR)	;get parameter
	LD	A,H		;anything?
	OR	L
	JR	Z,CKDAT		;nope, check date
;
	LD	DE,DCB		;DCB area for file
	LD	A,FSPEC		;check for valid filespec
	RST	SVC		;is it?
	JP	NZ,SYSRET	;nope, generate error
;
	INC	DE		;bump to normal DCB
	LD	HL,CMD		;default extension
	LD	A,FEXT		;SVC #
	RST	SVC		;add it if you can
;
	LD	A,(DCB)		;get flags
	BIT	6,A		;file here?
	LD	A,81		;invalid channel
	JP	Z,SYSRET	;nope, abort
;
	LD	A,OPEN		;SVC #
	LD	HL,OLIST	;open list
	RST	SVC		;open/create the file
	JP	NZ,SYSRET	;error in opening
;
	LD	A,-1		;must reset high overlay
	LD	(OVLYH),A	;for re-load
	CALL	WRITDATA	;write data to file
	JP	NZ,SYSRET	;error, abort
;
	LD	DE,DCB+1	;DCB
	LD	A,CLOSE		;SVC #
	RST	SVC		;close the file
	JP	NZ,SYSRET	;error, abort
;
;
;	check for date prompts
;
CKDAT	LD	IX,DFLAGS	;data flags
	LD	(IX),0		;set all nil
;
	LD	A,(DATPAR)	;date param
	LD	(IX+1),A	;save it
	INC	A		;yes?
	JR	Z,DATSET	;OK
	DEC	A		;no?
	JR	NZ,CKTIM	;check for TIME
;
DATSET	SET	1,(IX)		;set the flag
;
;	check for time
;
CKTIM	LD	A,(TIMPAR)	;get parameter
	LD	(IX+3),A	;save it
	INC	A		;yes?
	JR	Z,TIMSET	;go
	DEC	A		;no?
	JR	NZ,CKLOG	;nope, check logo
;
TIMSET	SET	3,(IX)		;set the flag
;
;	check for LOGO
;
CKLOG	LD	A,(LOGPAR)	;get parameter
	LD	(IX+2),A	;save it
	INC	A		;on?
	JR	Z,LOGSET	;set it
	DEC	A		;off?
	JR	NZ,CKWRT	;nope, see if anything
;
LOGSET	SET	2,(IX)		;set the flag
;
CKWRT	LD	A,(IX)		;get the flag
	OR	A		;anything input?
	JP	Z,SYSRET	;nope, all done
;
;	write back bootup data to boot sector
;
	LD	C,0		;drive 0
	CALL	LOCDCT		;find the DCT
	LD	A,(IY+14)	;get flags
	PUSH	AF		;save 'em
	RES	7,(IY+14)	;set single den
;
	LD	HL,BUFFER	;I/O buffer
	LD	DE,0002H	;track 0, sector 0
	LD	B,C		;BC = 0
	LD	A,DREAD		;sector read
	RST	DISKIO		;read it in
	POP	BC		;get flag back
	LD	(IY+14),B	;put it back
	JP	NZ,SYSRET	;error, abort it
;
	BIT	1,(IX)		;date change?
	JR	Z,CKWRT1	;nope
;
	LD	A,(IX+1)
	LD	(BUFFER+10H),A	;put into data
;
CKWRT1	BIT	2,(IX)		;logo change?
	JR	Z,CKWRT2	;nope
;
	LD	A,(IX+2)
	LD	(BUFFER+11H),A	;put into data
;
CKWRT2	BIT	3,(IX)		;time change?
	JR	Z,CKWRT3	;nope
;
	LD	A,(IX+3)	;get data
	LD	(BUFFER+12H),A	;put it in
;
CKWRT3	LD	A,(IY+14)	;get flag
	PUSH	AF		;save it
	RES	7,(IY+14)	;set single den
;
	LD	C,0		;drive 0
	LD	B,C		;BC=0
	LD	A,DWRITE	;sector write
	RST	DISKIO		;write it back
	POP	BC		;get flags
	LD	(IY+14),B	;put 'em back
	JP	SYSRET		;if error, display it
;
	PAGE
;
;	position HL to input command
;
	INC	HL
POSHL	LD	A,(HL)
	CP	' '
	JR	Z,POSHL-1
	CP	','
	JR	Z,POSHL-1
	CP	13
	RET	Z
	CP	';'
	RET	Z
	CP	3
	RET
;
	PAGE
;
;	write system data to config file
;
WRITDATA LD	HL,(PHYMEM)	;get physical memory
	LD	DE,(HIMEM)	;get high memory
	OR	A		;clear carry
	SBC	HL,DE		;anything here?
	JR	Z,NOHIMEM	;nothing in high memory
	JR	C,NOHIMEM	;invalid data set
;
;	high memory data, set vectors
;
	LD	(MEMWHR),DE	;save start
	INC	HL		;inclusive addresses
	LD	(MEMLEN),HL	;save length
;
	JR	DATAGO		;continue
;
;	no high memory data, disable vector
;
NOHIMEM	LD	HL,0		;set word of 0000
	LD	(MEMVEC),HL	;disable JR opcode
;
;	write program init code to file
;
DATAGO	LD	HL,DCBCODE	;code for init
	LD	DE,2200H	;loading address
	LD	BC,DCBCODEL	;length of data
	CALL	PUTDATA		;put this block(s)
	RET	NZ		;error, return
;
;	write low sys0 pages to file
;
;	don't write clock/date area
;
	LD	HL,0000H	;start page 0
	LD	DE,2800H	;loading address
	LD	BC,150H		;up to TIME$
	CALL	PUTDATA		;write it out
	RET	NZ		;error, return
;
	LD	HL,0157H	;balance page 1
	LD	DE,2957H	;loading address
	LD	BC,500H-157H	;length of balance
	CALL	PUTDATA		;write it out
	RET	NZ		;error, return
;
;	check for writing high memory drivers
;
	LD	HL,(MEMVEC)	;anything in himem?
	LD	A,H		;is it 0000?
	OR	L
	JR	Z,NOTMEM	;not this block
;
	LD	HL,(MEMWHR)	;get data start
	LD	DE,2D00H	;loading address
	LD	BC,(MEMLEN)	;get length
	CALL	PUTDATA		;write it out
	RET	NZ		;error, return
;
NOTMEM	LD	A,02H		;entry point block
	CALL	PUTIN		;put it in
	RET	NZ		;error
	LD	A,02H
	CALL	PUTIN
	RET	NZ
;
	LD	A,00H		;entry point address
	CALL	PUTIN
	RET	NZ
	LD	A,22H		;entry = 2200H
	JR	PUTIN		;put it in and return
;
	PAGE
;
;	insert data into file
;
;	ENT	HL => data area
;		DE =  loading address
;		BC =  length of block
;
;	EXT	Z = OK
;		NZ = A = error code
;
PUTDATA	INC	B		;any more pages?
	DEC	B
	JR	NZ,PUTBLK	;nope, put in a block
;
	INC	C		;any partial left?
	DEC	C
	RET	Z		;all done, return
	JR	INSBLK		;insert last block
;
PUTBLK	PUSH	BC		;save counter
	LD	C,0		;one full page
	CALL	INSBLK		;insert a block
	POP	BC		;get counter
	RET	NZ		;error, return
	DEC	B		;less one page
	JR	PUTDATA		;continue
;
INSBLK	LD	A,1		;byte to put into file
	CALL	PUTIN		;put it in
	RET	NZ		;error, return
;
	LD	A,C		;get length
	INC	A		;+2 for address
	INC	A
	CALL	PUTIN		;put it in
	RET	NZ		;error, return
;
	LD	A,E		;get address
	CALL	PUTIN		;put it in
	RET	NZ
	LD	A,D
	CALL	PUTIN
	RET	NZ
;
PUTLP	LD	A,(HL)		;get a byte
	CALL	PUTIN		;put it in
	RET	NZ		;error, return
	INC	HL		;bump data address
	INC	DE		;bump load address
	DEC	C		;less counter
	JR	NZ,PUTLP	;finish it off
	RET			;else return ZERO
;
PUTIN	PUSH	BC		;save it
	PUSH	DE		;this too
	LD	B,A		;pass the byte
	LD	DE,DCB+1	;DCB to use
	LD	A,PUT		;SVC #
	RST	SVC		;put into file
	POP	DE
	POP	BC		;get it back
	RET			;done
;
	PAGE
;
;	$CONFIG	- configure disk drives
;
;	CONFIG,param,param,...
;
;	params:
;
;	Floppies:
;
;	(F)loppy = switch	- sets FLOPPY driver
;	(W)p	 = switch	- software write protect
;	(M)d	 = switch	- motor on delay
;	(H)l	 = switch	- head load delay
;	(S)tep	 = value	- track-track step time
;	 Skip	 = switch	- double step the drive
;	 Size	 = value	- 5 or 8 inch drive
;	(P)d	 = value	- physical drive #
;
;	Rigid params:
;
;	(R)igid	 = switch	- sets RIGID driver
;	(W)p	 = switch	- software write protect
;	(S)tep	 = value	- track step rate
;	(H)o	 = value	- head offset
;	 Hc	 = value	- head count
;	(T)s	 = value	- sectors/track
;	(P)d	 = value	- physical drive #
;	 Size	 = value	- 5 or 8 inch drive
;	(F)ixed	 = switch	- fixed/removable
;	(C)o	= value		- cylinder offset
;
;	limits:
;
;	step rate for floppies = 0-3 only
;	physical drive = 0-3 only
;
;
CONFIG	CALL	POSHL		;position to input
	JP	Z,SHOWCON	;display settings
;
	LD	DE,DCB		;use RUN DCB to evaluate
	LD	A,FSPEC		;fetch drivespec
	RST	SVC		;fetch it
	JP	NZ,EXIT		;error, abort
;
	LD	A,(DE)		;get flags
	LD	B,32		;error code, bad drive
	BIT	7,A		;device here?
	JP	Z,EXITB		;error
	BIT	6,A		;filespec?
	JP	NZ,EXITB	;filespec here, bad
	AND	0FH		;low bits only
	SUB	8		;0-7?
	JP	C,EXITB		;go error
;
	LD	C,A		;need it here
	CALL	LOCDCT		;load IY with DCT
;
	PUSH	HL		;save pointer
	CALL	CLRDATA		;clear out PARM data
	LD	HL,-1		;special param
	LD	(SAVPAR),HL	;for head offset
	POP	HL		;restore pointer
;
	CALL	POSHL		;any more?
	JR	NZ,MORESTF	;more stuff, continue
	CALL	SHOWDRV		;show single drive
	XOR	A		;set Z
	RET			;done
;
MORESTF	LD	DE,CPARM	;param block for config
	LD	A,PARAM		;SVC #
	RST	SVC
	JP	NZ,EXIT		;error, abort
;
;	evaluate input parameters
;
	LD	A,(BRKPAR)	;floppy set?
	INC	A		;yes?
	JR	Z,SETFLP	;yes, go
	DEC	A		;no?
	JR	Z,SETRIG	;yes, go?
;
;	check for rigid
;
NOFLP	LD	A,(ALVPAR)	;param RIGID
	INC	A		;yes?
	JR	Z,SETRIG	;yes, go
	DEC	A		;no?
	JR	Z,SETFLP	;set floppy
;
;	neither floppy nor hard, use current
;
NOTHIN	BIT	5,(IY+5)	;rigid?
	JR	NZ,SETRIG	;yes, go!
;
;	setup routine for floppies
;
;	check for software write protect
;
SETFLP	RES	5,(IY+5)	;set floppy
	SET	0,(IY+5)	;force init
	CALL	SETWP		;set write protect
;
;	check for motor on delay
;
CKFMD	LD	A,(DATPAR)	;motor on delay?
	INC	A		;yes?
	JR	Z,MDON		;turn on
	DEC	A		;no?
	JR	NZ,CKFHL	;check head load
;
MDOFF	RES	4,(IY+5)	;turn if off
	JR	CKFHL		;continue
;
MDON	SET	4,(IY+5)	;turn it on
;
;	check for head load delay
;
CKFHL	LD	A,(TIMPAR)	;head load?
	INC	A		;on?
	JR	Z,HLON		;yes, go
	DEC	A		;off?
	JR	NZ,CKFST	;nope, check step
;
HLOFF	RES	3,(IY+5)	;turn it off
	JR	CKFST		;continue
;
HLON	SET	3,(IY+5)	;turn it on
;
;	check for step rate
;
CKFST	CALL	SETSTEP		;get it
	AND	3		;mask it off
	LD	(IY+6),A	;save it
;
;	check for skip
;
CKFSKP	LD	A,(LOGPAR)	;skip?
	INC	A		;on?
	JR	Z,SKPON		;yes, go
	DEC	A		;off?
	JR	NZ,CKSIZ	;no, check size
;
SKPOFF	RES	2,(IY+5)	;turn it off
	JR	CKSIZ		;continue
;
SKPON	SET	2,(IY+5)	;turn it on
;
;	check for size of drive
;
CKSIZ	CALL	SETSIZ		;setup size of drive
	JP	NZ,EXIT		;error
;
;	check for physical drive
;
CKFPD	CALL	SETPD		;set physical drive
	XOR	A		;done, return
	RET
;
;
;	setup for rigid drive
;
;	check for software write protect
;
SETRIG	SET	5,(IY+5)	;set rigid
	SET	0,(IY+5)	;force init next access
	CALL	SETWP		;set software WP
;
;	check for step rate
;
CKRSTP	CALL	SETSTEP		;set step rate
	LD	(IY+6),A	;put into DCT
;
;	check for head offset
;
CKRHO	LD	A,(HOPAR+1)	;anything?
	OR	A
	JR	NZ,CKRCO	;nope, continue
;
	LD	A,(HOPAR)
	LD	(IY+7),A	;put in head offset
;
;	check for cylinder offset
;
CKRCO	LD	HL,(SAVPAR)	;anything?
	LD	A,H		;inited to FFFF
	AND	L
	INC	A		;anything?
	JR	Z,CKRHC		;nope, continue
;
	LD	(IY+8),L	;put in cyl offset
	LD	(IY+9),H	;MSB offset
;
;	check for surface count
;
CKRHC	LD	A,(HCPAR+1)	;anything?
	OR	A
	JR	NZ,CKRTS	;nope, continue
;
	LD	A,(HCPAR)	;get it
	LD	(IY+15),A	;save surface count
;
;	check for sectors / track
;
CKRTS	LD	A,(TSPAR+1)	;anything input?
	OR	A
	JR	NZ,CKRSIZ	;nope, check size
;
	LD	A,(TSPAR)
	LD	(IY+17),A	;sectors / track
;
	LD	E,A		;save it
	LD	D,0		;DE = sectors / track
	LD	B,(IY+15)	;get num surfaces
	LD	HL,0		;start
;
CKRTC	ADD	HL,DE		;sectors this track
	DJNZ	CKRTC		;get 'em all
	LD	(IY+22),L	;sects / cylinder
	LD	(IY+23),H
;
;	check for size of drive
;
CKRSIZ	CALL	SETSIZ		;set it up
	JP	NZ,EXIT		;error, abort
;
;	check for fixed/removable
;
CKRFIX	LD	A,(FIXPAR)	;get param
	INC	A		;yes?
	JR	Z,SETFIX	;set it up
	DEC	A		;no?
	JR	NZ,CKRPD	;nope, get physical drive
;
SETREM	SET	1,(IY+5)	;set removable
	JR	CKRPD		;continue
;
SETFIX	RES	1,(IY+5)	;set fixed
;
;	check for physical address
;
CKRPD	CALL	SETPD		;set it up
	XOR	A		;all done
	RET
;
;
;	set software write protect
;
SETWP	LD	A,(TRCPAR)	;get parameter
	INC	A		;yes?
	JR	Z,WPON		;yes, go
	DEC	A		;no?
	RET	NZ		;nope, nothing
;
WPOFF	RES	6,(IY+5)	;turn it off
	RET
;
WPON	SET	6,(IY+5)	;turn it on
	RET
;
;	set track/track step rate
;
SETSTEP	LD	A,(LOMPAR+1)	;anything?
	OR	A		;yes?
	LD	A,(IY+6)	;get existing
	RET	NZ		;nope, return
;
	LD	A,(LOMPAR)	;else fetch it
	RET			;and return
;
;
;	set physical drive number
;
SETPD	LD	A,(HIMPAR+1)	;anything input?
	OR	A
	RET	NZ		;nope, skip it
;
	LD	A,(HIMPAR)
	AND	7		;0-7 only
	LD	(IY+12),A	;put into DCT
	RET			;done
;
;	set size of drive
;
SETSIZ	LD	A,(SIZPAR+1)	;see if anything
	OR	A		;anything entered?
	JP	NZ,RETURN	;skip, return Z
;
	LD	A,(SIZPAR)	;get the input
	CP	5		;5"
	JR	Z,SET5		;set it up
	CP	8		;8"
	LD	A,ERR98		;data out of range
	RET	NZ		;error, abort
;
SET8	RES	7,(IY+5)	;set 8"
	RET
;
SET5	SET	7,(IY+5)	;set 5"
	RET
	PAGE
;
;	display configuration
;
SHOWCON	LD	BC,0800H	;B=looper, C=drive
;
SHOWCLP	PUSH	BC		;save it
	CALL	SHOWDRV		;display this drive
	JP	NZ,EXIT		;error! abort
	POP	BC		;restore
	INC	C		;bump drive
	DJNZ	SHOWCLP		;finish all 8
	XOR	A		;done
	RET			;return
;
SHOWDRV	CALL	LOCDCT		;locate the DCT
;
	LD	A,C		;get relative drive
	LD	HL,CO0		;text
	ADD	A,8		;make it rel device
	CALL	ASCII2		;2 digit ascii
;
;	fetch real drive name
;
	LD	A,C		;get drive number
	ADD	A,8		;make it real
	ADD	A,A		;X2
	ADD	A,A		;X4
	ADD	A,2		;+ 2 for name offset
	LD	L,A		;give to L
	LD	H,PAGE1		;HL => drive name
	LD	A,(HL)		;get a char
	LD	(CO1),A		;to the string
	INC	HL		;next char
	LD	A,(HL)		;get it
	LD	(CO1+1),A	;to the string
;
;	display data source
;
	LD	HL,COM0		;start of string
	LD	BC,COM0L<8+0	;len + term
	LD	A,VDLINE	;display it
	RST	SVC		;!
	RET	NZ		;error!
;
;	check for nil drive
;
	LD	HL,NILMSG	;nil
	LD	BC,NILMSGL<8+13	;len + term
	LD	A,VDLINE	;SVC #
	BIT	3,(IY)		;enabled?
	JP	NZ,SVC		;go if not
;
;	check soft WP
;
	LD	HL,2020H	;spaces
	BIT	6,(IY+5)	;write protected?
	JR	Z,NOTWP		;nope
	LD	HL,5057H	;WP
NOTWP	LD	(CO2),HL	;to the string
	LD	(COO2),HL	;2 strings
;
	LD	A,'5'		;5" drive
	BIT	7,(IY+5)
	JR	NZ,MMY1
	LD	A,'8'		;8" drive
MMY1	LD	(CO3),A		;to the string
	LD	(COO3),A	;2 strings
;
;	get physical drive
;
	LD	A,(IY+12)	;binary drive #
	AND	0FH
	ADD	A,'0'
	LD	(CO5),A		;to the string
	LD	(COO5),A	;2 strings
;
;	get cylinder count
;
	LD	A,(IY+16)	;cylinder count
	LD	HL,CO6		;where it goes
	CALL	ASCII		;make it ascii
	LD	A,(IY+16)	;again
	LD	HL,COO6		;2 strings
	CALL	ASCII		;this one too
;
;	check for floppy/rigid
;
	BIT	5,(IY+5)	;rigid?
	JR	NZ,SHOWRIG	;yes, go!
;
;	floppy, continue
;
	LD	A,'S'
	BIT	7,(IY+14)
	JR	Z,MMY3
	LD	A,'D'
MMY3	LD	(CO8),A		;put in density
;
	LD	A,(IY+15)	;surface count
	ADD	A,'0'
	LD	(CO7),A		;to the string
;
	LD	A,'Y'		;motor delay
	BIT	4,(IY+5)
	JR	NZ,MMY4
	LD	A,'N'
MMY4	LD	(CO10),A	;to the string
;
	LD	A,'Y'		;head load?
	BIT	3,(IY+5)	;yes
	JR	NZ,MMYY4	;go
	LD	A,'N'
MMYY4	LD	(CO11),A	;to the string
;
	LD	A,(IY+6)	;step rate
	AND	3		;0 - 3 only
	ADD	A,'0'		;make it ascii
	LD	(CO9),A		;to the string
;
	LD	A,'Y'		;skip?
	BIT	2,(IY+5)	;yes?
	JR	NZ,MMYY44
	LD	A,'N'
MMYY44	LD	(CO12),A	;to the string
;
	LD	HL,CO2		;message
	LD	BC,CO2L<8+13	;len + term
	LD	A,VDLINE
	RST	SVC		;display it
;
	RET			;done
;
;	rigid, set params
;
SHOWRIG	LD	HL,FIXMSG	;fixed?
	BIT	1,(IY+5)	;yes?
	JR	Z,SHOW1R	;yes, go!
	LD	HL,REMMSG	;removable
;
SHOW1R	LD	DE,COO4		;string
	LD	BC,3		;length
	LDIR			;move it in
;
	LD	A,(IY+15)	;surface count
	ADD	A,'0'		;make it ascii
	LD	(COO7),A	;to the string
;
	LD	HL,COO8		;string
	LD	A,(IY+6)	;get step
	CALL	ASCII		;move it in
;
	LD	A,(IY+7)	;head offset
	ADD	A,'0'		;make it ascii
	LD	(COO9),A	;to the string
;
	LD	A,(IY+8)	;cylinder offset
	LD	HL,COO10	;string
	CALL	ASCII		;put it in
;
	LD	A,(IY+17)	;sectors / track
	LD	HL,COO11	;string
	CALL	ASCII		;move it in
;
	LD	HL,COO2		;text
	LD	BC,COO2L<8+13	;len + term
	LD	A,VDLINE	;SVC #
	RST	SVC		;display it
	RET
;
	PAGE
;
;	$ASCII	- binary to ASCII (HL) 3 digits
;	$ASCII2	- binary to ASCII (HL) 2 digits
;
ASCII	LD	B,'0'		;start digit
ASCL	SUB	100		;less 100
	JR	C,ASC1		;have it
	INC	B		;bump ascii
	JR	ASCL		;continue
ASC1	PUSH	AF		;save it
	LD	A,B		;get it
	CP	'0'		;nil?
	JR	NZ,ASC11	;go if not
	LD	B,' '		;else space it out
ASC11	LD	(HL),B		;put in string
	POP	AF
	ADD	A,100		;add it back
	INC	HL		;bump pointer
ASCII2	LD	B,'0'		;restart it
ASC2	SUB	10		;less 10's place
	JR	C,ASC3		;done, put it in
	INC	B		;bump ascii
	JR	ASC2
ASC3	LD	(HL),B		;put in NSB
	INC	HL		;bump pointer
	ADD	A,'0'+10	;ascii + last sub
	LD	(HL),A		;put it in
	RET			;done
;
;	clear out data area for PARM call
;
CLRDATA	LD	HL,BRKPAR	;first block
	LD	A,80H		;switch nil byte
	LD	B,28		;28 bytes long
;
FILL	LD	(HL),A		;put in a byte
	INC	HL		;bump pointer
	DJNZ	FILL		;do the rest
	RET
;
;	data area
;
;	parameter block for $SYSTEM
;
SPARM	DEFB	20H+4		;switch + length -1
	DEFW	BRKPAR		;data vector
	DEFM	'BREAK'		;parameter
;
	DEFB	20H+4
	DEFW	ALVPAR
	DEFM	'ALIVE'
;
	DEFB	40H+4
	DEFW	LOMPAR
	DEFM	'LOMEM'
;
	DEFB	40H+4
	DEFW	HIMPAR
	DEFM	'HIMEM'
;
	DEFB	80H+3
	DEFW	SAVPAR
	DEFM	'SAVE'
;
	DEFB	20H+3
	DEFW	DATPAR
	DEFM	'DATE'
;
	DEFB	20H+3
	DEFW	TIMPAR
	DEFM	'TIME'
;
	DEFB	20H+4
	DEFW	TRCPAR
	DEFM	'TRACE'
;
	DEFB	20H+3
	DEFW	LOGPAR
	DEFM	'LOGO'
;
	DEFB	0		;terminator
;
;	parameter block for $CONFIG
;
CPARM	DEFB	20H+5		;switch + length -1
	DEFW	BRKPAR		;vector for data
	DEFM	'FLOPPY'
;
	DEFB	20H+1
	DEFW	TRCPAR
	DEFM	'WP'
;
	DEFB	20H+1
	DEFW	DATPAR
	DEFM	'MD'
;
	DEFB	20H+1
	DEFW	TIMPAR
	DEFM	'HL'
;
	DEFB	40H+3		;value
	DEFW	LOMPAR
	DEFM	'STEP'
;
	DEFB	40H+1
	DEFW	HIMPAR
	DEFM	'PD'
;
	DEFB	20H+4
	DEFW	ALVPAR
	DEFM	'RIGID'
;
	DEFB	40H+1
	DEFW	SAVPAR
	DEFM	'CO'
;
	DEFB	40H+1
	DEFW	TSPAR
	DEFM	'TS'
;
	DEFB	20H+3
	DEFW	LOGPAR
	DEFM	'SKIP'
;
	DEFB	40H+3
	DEFW	SIZPAR
	DEFM	'SIZE'
;
	DEFB	40H+1
	DEFW	HOPAR
	DEFM	'HO'
;
	DEFB	40H+1
	DEFW	HCPAR
	DEFM	'HC'
;
	DEFB	20H+4
	DEFW	FIXPAR
	DEFM	'FIXED'
;
	DEFB	0
;
;	switch area
;
BRKPAR	DEFW	0		;break, FLOPPY
ALVPAR	DEFW	0		;alive, RIGID
TRCPAR	DEFW	0		;trace, WP
DATPAR	DEFW	0		;date, MD
TIMPAR	DEFW	0		;time, HL
LOGPAR	DEFW	0		;logo, SKIP
FIXPAR	DEFW	0		;FIXED
;
;	value/string area
;
TSPAR	DEFW	0		;TS
SIZPAR	DEFW	0		;SIZE
HOPAR	DEFW	0		;HO
HCPAR	DEFW	0		;HC
LOMPAR	DEFW	0		;lomem, STEP
HIMPAR	DEFW	0		;himem, PD
SAVPAR	DEFW	0		;save, CO
;
;
DFLAGS	DEFB	0		;flag
	DEFB	0		;date command
	DEFB	0		;logo command
	DEFB	0		;time command
;
;	open parameter list
;
OLIST	DEFW	BUFFER		;buffer addr
	DEFW	BUFFER		;record addr
	DEFW	0000H		;eodad addr
	DEFB	'P'		;write program file
	DEFB	0		;record length
	DEFB	'F'		;fixed length
	DEFB	2		;open/create file
	DEFB	0		;terminator
;
SYSMSG	DEFM	'Lomem='
SYSMSG4	DEFM	'xxxxH, Himem='
SYSMSG5	DEFM	'xxxxH, Phymem='
SYSMSG6	DEFM	'xxxxH'
SYSMSGL	EQU	$-SYSMSG
;
COM0	DEFM	'$'
CO0	DEFM	'xx :'
CO1	DEFM	'xx'
COM0L	EQU	$-COM0
;
CO2	DEFM	'xx '
CO3	DEFM	'x" Floppy PD='
CO5	DEFM	'x Cyls='
CO6	DEFM	'xxx Sides='
CO7	DEFM	'x Den='
CO8	DEFM	'x Step='
CO9	DEFM	'x MDelay='
CO10	DEFM	'x HLoad='
CO11	DEFM	'x Skip='
CO12	DEFM	'x'
CO2L	EQU	$-CO2
;
COO2	DEFM	'xx '
COO3	DEFM	'x" Rigid  PD='
COO5	DEFM	'x Cyls='
COO6	DEFM	'xxx '
COO4	DEFM	'xxx HCnt='
COO7	DEFM	'x Step='
COO8	DEFM	'xxx HOff='
COO9	DEFM	'x COff='
COO10	DEFM	'xxx TSec='
COO11	DEFM	'xxx'
COO2L	EQU	$-COO2
;
NILMSG	DEFM	'   Nil'
NILMSGL	EQU	$-NILMSG
;
FIXMSG	DEFM	'Fix'
;
REMMSG	DEFM	'Rem'
;
CMD	DEFM	'CMD'		;default extension
;
	PAGE
;
;	$DCBINIT - code to initialize DCB's
;
;
LOCDCB	EQU	032AH		;locate DCB
LOCDCT	EQU	032DH		;locate DCT
KEYBUFF	EQU	1AA0H		;keyboard buffer
;
KBINIT	EQU	1		;init keyboard
VDINIT	EQU	7		;init video
PRINIT	EQU	17		;init printer
RS232C	EQU	55		;init RS232
;
SVC	EQU	08H		;execute SVC
;
DDCB	EQU	1		;display DCB #
PRDCB	EQU	2		;printer DCB #
;
RETN	EQU	45EDH		;RETN opcode
;
;
;	$DCBINIT - init all DCBS
;
;
;	move data to correct areas
;
DCBCODE	LD	A,DDCB		;display DCB
	CALL	LOCDCB		;find the DCB
	LD	A,(IX+9)	;fetch mode mask
	AND	0DFH		;mask off RTC
	OUT	(0FFH),A	;turn off RTC
;
	LD	HL,2800H	;start data block
	LD	DE,0000H	;goes here
	LD	BC,150H		;length
	LDIR			;move it down
	LD	HL,2957H	;rest is here
	LD	DE,157H		;goes here
	LD	BC,500H-157H	;length of reset
	LDIR			;move it down
;
MEMVEC	JR	MOVTOP		;move top memory in
;
MEMRET	LD	A,(IX+9)	;re-fetch mask
	OUT	(0FFH),A	;re-enable RTC
	IN	A,(0FEH)	;clear latch
	JR	INITS		;init 'em
;
MOVTOP	LD	HL,2D00H	;data is here
	LD	DE,0		;where it goes
MEMWHR	EQU	$-2
	LD	BC,0		;how long it is
MEMLEN	EQU	$-2
	LDIR			;move it in
	JR	MEMRET		;continue
;
;	initialize
;
INITS	LD	A,KBINIT	;SVC #
	RST	SVC		;init it
;
;	initialize display
;
	LD	A,DDCB		;display DCB
	CALL	LOCDCB		;find it
;
	LD	A,(IX+10)	;get flag
	AND	80H		;normal reverse
	CPL			;reverse it
	LD	C,A		;save param
;
	LD	A,(IX+9)	;get flag
	AND	10H		;char/line
	CPL			;reverse it
	LD	B,A		;save param
;
	LD	A,VDINIT	;video init
	RST	SVC		;init it
;
;	initialize printer
;
	LD	A,PRDCB		;DCB #
	CALL	LOCDCB		;find it
;
	LD	B,(IX+20)	;page length
	LD	C,(IX+19)	;printed lines
	LD	D,(IX+22)	;max chars/line
;
	LD	A,PRINIT	;SVC #
	RST	SVC		;init it
;
;	initialize RS232 channels
;
	LD	A,'A'		;channel A
	JR	INITRS		;init it
BACK1	LD	A,'B'		;channel B
	JR	INITRS		;init it
;
;	initialize all disk drives
;
BACK2	LD	BC,0800H	;B=looper, C=drive
;
DRVLP	CALL	LOCDCT		;locate the DCT
	SET	0,(IY+5)	;force an init next time
;
	INC	C		;bump drive
	DJNZ	DRVLP		;do all 8
;
	LD	B,1BH		;clear screen
	LD	A,VDCHAR	;SVC #
	RST	SVC		;clear it
;
;	all done, exit back to DOS
;
	XOR	A		;set ZERO
	RET			;back to caller
;
INITRS	LD	HL,KEYBUFF	;use keyboard buffer
	LD	(HL),A		;put in the data area
	SUB	'A'		;remove ascii
	ADD	A,3		;adjust to DCB #
	CALL	LOCDCB		;load IX with DCB
;
	BIT	1,(IX+5)	;channel initialized?
	JR	NZ,INITRSO	;turn it off
;
	LD	A,(IX+25)	;get flag byte
	PUSH	HL		;save pointer
	INC	HL		;bump it
;
;	fetch baud rate
;
	PUSH	AF		;save byte
	RRCA			;align it to low bits
	RRCA
	RRCA
	RRCA
	AND	7		;low 3 only
	INC	A		;adjust for 1-8
	LD	(HL),A		;put into param block
	POP	AF		;restore it
	INC	HL		;bump it
;
;	fetch word length
;
	PUSH	AF		;save again
	RRCA			;align it
	RRCA
	AND	3		;2 bits
	ADD	A,5		;adjust to actual
	LD	(HL),A		;put into block
	POP	AF		;restore
	INC	HL		;next
;
;	fetch parity
;
	LD	B,'N'		;no parity
	AND	3		;low 2 bits
	JR	Z,RSIG		;have it
	DEC	A		;1?
	LD	B,'O'		;odd parity
	JR	Z,RSIG		;have it
	LD	B,'E'		;even parity
;
RSIG	LD	(HL),B		;put in buffer
	INC	HL		;bump pointer
;
;	fetch stop bits
;
	LD	A,(IX+23)	;get flag
	AND	3		;low 2 only
	LD	(HL),A		;put in buffer
;
;	insert terminator
;
	INC	HL		;bump pointer
	LD	(HL),0		;insert it
;
	POP	HL		;get start back
	LD	B,-1		;turn on channel
;
INITCONT LD	A,RS232C	;init the RS232
	RST	SVC		;do it
;
RSIRET	LD	A,(KEYBUFF)	;get which one done
	CP	'A'		;channel A?
	JR	Z,BACK1		;yes, do B
	JR	BACK2		;no, continue
;
INITRSO	LD	B,0		;turn off channel
	JR	INITCONT	;continue
;
DCBCODEL EQU	$-DCBCODE
;
BUFFER	EQU	$
;
	END	VECTORS
