;dossys5/asm - kjw/bqsd - 08/72
;
; low overlay	1C00-21FF
; high overlay	2200-27FF
;
	ORG	1C00H		;Low Overlay
;
	TITLE	'<DOS+ II.A - SYS05/SYS>'
;
; first 32 bytes is a vector tables of routines
;
;	(message text and numbers at end of file)
;
;
FLAGK3	EQU	0168H		;last posted error
SVC	EQU	8		;execute SVC
DDCB	EQU	1		;display DCB #
LOCDCB	EQU	032AH		;load IX with DCB
;
VECTORS	DW	RETURN		;0
	DW	ERROR		;1
	DW	ERRMSG		;2
	DW	DUMMY		;3
	DW	DUMMY		;4
	DW	DUMMY		;5
	DW	DUMMY		;6
	DW	DUMMY		;7
	DW	DUMMY		;8
	DW	DUMMY		;9
	DW	DUMMY		;10
	DW	DUMMY		;11
	DW	DUMMY		;12
	DW	DUMMY		;13
	DW	DUMMY		;14
	DW	DUMMY		;15
;
DUMMY	LD	A,1		;"bad function code"
	OR	A		;set NZ flag
	RET			;return in error
;
; ERROR
; ENTRY:  B = Error Number (0-98)
; EXIT:   Error message displayed to video
;	  NZ = A = error code
;	  Z  = OK
;
ERROR	PUSH	BC		;save it
	PUSH	HL		;save this too
	LD	HL,SYS5BUF	;sys5 work buffer
	RES	7,B		;force a return to here
	LD	A,B		;get number
	LD	(FLAGK3),A	;save it
	CALL	ERRMSG		;load (HL) with message
;
;	remove trailing spaces
;
	LD	BC,4EH		;length -2
	ADD	HL,BC		;point to 2nd last char
	LD	B,4FH		;max length = 79 chars
	LD	A,' '		;looking for spaces
;
STRIP	CP	(HL)		;space here?
	JR	NZ,ERRPUT	;done, display it
	DEC	HL		;backspace pointer
	DJNZ	STRIP		;dec counter, next char
;
ERRPUT	LD	HL,SYS5BUF	;start of text
	LD	A,9		;SVC VDLINE
	LD	C,13		;B=length, C=term char
	RST	8		;via SVC call
	CALL	NZ,RESVID	;reset video
;
ERRET	POP	HL		;restore stack
	POP	BC
	LD	A,B		;get error code
	AND	80H		;check bit 7
	RET	Z		;Z flag for OK, return
	RST	0		;else go "dos ready"
;
;	reset video link/route
;
RESVID	PUSH	IX		;save it
	LD	A,DDCB		;display DCB #
	CALL	LOCDCB		;find it
	RES	5,(IX)		;reset link
	RES	4,(IX)		;reset route
	POP	IX		;restore
	XOR	A		;return zero
	RET			;done
;
; ERRMSG
; ENTRY:   B  = Error Code (0-98)
;	   HL => 80 char text buffer
; EXIT:    HL => 80 char error string
;	   NZ = A = error code
;	   Z  = OK
;
ERRMSG	PUSH	BC		;save entry
	PUSH	HL		;save string pointer
	PUSH	DE		;need to use this
	PUSH	HL		;again for work use
	LD	A,B		;get the error
	AND	7FH		;mask off command bit
	LD	B,79		;string length -1
ERRNUL	LD	(HL),20H	;put one
	INC	HL		;bump pointer
	DJNZ	ERRNUL		;do whole thing
	LD	(HL),13 	;put C/R at end
	POP	DE		;get start back
	LD	HL,TABLE2	;command lookup table
	CP	107		;106 errors here
	JR	C,FINDERR	;valid if <45
	LD	A,6		;else force undefined
	JR	FINDERR 	;go, B = err # counter
ERRDONE	POP	DE		;restore DE
	JR	ERRET		;pop stack and return
FINDERR BIT	7,(HL)		;high bit on ?
	INC	HL		;bump pointer
	JR	Z,FINDERR	;continue
	CP	B		;correct one ?
	JR	Z,SHOERR	;yes, display it
	INC	B		;bump counter
	JR	FINDERR 	;continue through table
SHOERR	DEC	HL		;point to start of line
	JR	ERRGO		;go do error
ERRLP	BIT	7,(HL)		;terminator?
	JR	NZ,ERRDONE	;finished
ERRGO	CALL	SHOW1		;show the word
	INC	HL		;bump pointer
	JR	ERRLP		;continue with sentence
SHOW1	LD	A,(HL)		;get the byte
	AND	7FH		;turn off high bit
	LD	C,1		;counter
	PUSH	HL		;save pointer
	LD	HL,TABLE1	;word table
FINDSHO BIT	7,(HL)		;high bit on/word start?
	INC	HL		;bump pointer
	JR	Z,FINDSHO	;continue if not
	CP	C		;one we want ?
	JR	Z,PUTERR	;display the word
	INC	C
	JR	FINDSHO 	;else continue
PUTERR	DEC	HL		;word start
	JR	PUTCONT 	;print it
PUTLOOP BIT	7,(HL)		;end of word?
	JR	NZ,WORDEND
PUTCONT LD	A,(HL)		;get char
	AND	7FH		;remove high bit
	LD	(DE),A		;put into buffer
	INC	DE		;bump buffer
	INC	HL		;bump word pointer
	JR	PUTLOOP 	;continue
WORDEND LD	A,20H		;display a space
	LD	(DE),A		;put in buffer
	INC	DE		;bump pointer
	POP	HL		;restore table pointer
RETURN	XOR	A		;set Z
	RET			;done
;
	PAGE
;
; table of words numbered 1-127
; high bit of first char in each word is set
; 80H is the table terminator
;
TABLE1	EQU	$
	DEFB	'N'+80H         ;1 No
	DEFM	'o'
	DEFB	'E'+80H         ;2 Error
	DEFM	'rror'
	DEFB	'B'+80H         ;3 Bad
	DEFM	'ad'
	DEFB	'F'+80H         ;4 Function
	DEFM	'unction'
	DEFB	'C'+80H         ;5 Code
	DEFM	'ode'
	DEFB	'O'+80H         ;6 On
	DEFM	'n'
	DEFB	'S'+80H         ;7 SVC
	DEFM	'VC'
	DEFB	'C'+80H         ;8 Call
	DEFM	'all'
	DEFB	'C'+80H         ;9 Character
	DEFM	'haracter'
	DEFB	'N'+80H         ;10 Not
	DEFM	'ot'
	DEFB	'A'+80H         ;11 Avaliable
	DEFM	'vailable'
	DEFB	'P'+80H         ;12 Parameter
	DEFM	'arameter'
	DEFB	'C'+80H         ;13 CRC
	DEFM	'RC'
	DEFB	'D'+80H         ;14 Disk
	DEFM	'isk'
	DEFB	'I'+80H         ;15 I/O
	DEFM	'/O'
	DEFB	'O'+80H         ;16 Operation
	DEFM	'peration'
	DEFB	'S'+80H         ;17 Sector
	DEFM	'ector'
	DEFB	'F'+80H         ;18 Found
	DEFM	'ound'
	DEFB	'I'+80H         ;19 Illegal
	DEFM	'llegal'
	DEFB	'C'+80H         ;20 Change
	DEFM	'hange'
	DEFB	'D'+80H         ;21 Drive
	DEFM	'rive'
	DEFB	'R'+80H         ;22 Ready
	DEFM	'eady'
	DEFB	'I'+80H         ;23 Invalid
	DEFM	'nvalid'
	DEFB	'D'+80H         ;24 Data
	DEFM	'ata'
	DEFB	'P'+80H         ;25 Provided
	DEFM	'rovided'
	DEFB	'F'+80H         ;26 File
	DEFM	'ile'
	DEFB	'A'+80H         ;27 Already
	DEFM	'lready'
	DEFB	'E'+80H         ;28 Exists
	DEFM	'xists'
	DEFB	'T'+80H         ;29 To
	DEFM	'o'
	DEFB	'O'+80H         ;30 Open
	DEFM	'pen'
	DEFB	'R'+80H         ;31 Read
	DEFM	'ead'
	DEFB	'W'+80H         ;32 Write
	DEFM	'rite'
	DEFB	'A'+80H         ;33 Attempt
	DEFM	'ttempt'
	DEFB	'O'+80H         ;34 Only
	DEFM	'nly'
	DEFB	'F'+80H         ;35 Fault
	DEFM	'ault'
	DEFB	'P'+80H         ;36 Protected
	DEFM	'rotected'
	DEFB	'D'+80H         ;37 DCB
	DEFM	'CB'
	DEFB	'H'+80H         ;38 Has
	DEFM	'as'
	DEFB	'B'+80H         ;39 Been
	DEFM	'een'
	DEFB	'M'+80H         ;40 Modified
	DEFM	'odified'
	DEFB	'D'+80H         ;41 Directory
	DEFM	'irectory'
	DEFB	'F'+80H         ;42 Filespec
	DEFM	'ilespec'
	DEFB	'G'+80H         ;43 GAT
	DEFM	'AT'
	DEFB	'H'+80H         ;44 HIT
	DEFM	'IT'
	DEFB	'A'+80H         ;45 Access
	DEFM	'ccess'
	DEFB	'D'+80H         ;46 Denied
	DEFM	'enied'
	DEFB	'S'+80H         ;47 Space
	DEFM	'pace'
	DEFB	'F'+80H         ;48 Full
	DEFM	'ull'
	DEFB	'E'+80H         ;49 End
	DEFM	'nd'
	DEFB	'O'+80H         ;50 Of
	DEFM	'f'
	DEFB	'E'+80H         ;51 Encountered
	DEFM	'ncountered'
	DEFB	'R'+80H         ;52 Record
	DEFM	'ecord'
	DEFB	'N'+80H         ;53 Number
	DEFM	'umber'
	DEFB	'O'+80H         ;54 Out
	DEFM	'ut'
	DEFB	'R'+80H         ;55 Range
	DEFM	'ange'
	DEFB	'C'+80H         ;56 Cannot
	DEFM	'annot'
	DEFB	'E'+80H         ;57 Extend
	DEFM	'xtend'
	DEFB	'P'+80H         ;58 Program
	DEFM	'rogram'
	DEFB	'D'+80H         ;59 Drivespec
	DEFM	'rivespec'
	DEFB	'L'+80H         ;60 Load
	DEFM	'oad'
	DEFB	'F'+80H         ;61 Format
	DEFM	'ormat'
	DEFB	'M'+80H         ;62 Memory
	DEFM	'emory'
	DEFB	'A'+80H         ;63 An
	DEFM	'n'
	DEFB	'U'+80H         ;64 Unopen
	DEFM	'nopen'
	DEFB	'S'+80H         ;65 Seek
	DEFM	'eek'
	DEFB	'L'+80H         ;66 Lost
	DEFM	'ost'
	DEFB	'P'+80H         ;67 Printer
	DEFM	'rinter'
	DEFB	'P'+80H         ;68 Paper
	DEFM	'aper'
	DEFB	'V'+80H         ;69 VLR Type
	DEFM	'LR Type'
	DEFB	'E'+80H		;70 Extended
	DEFM	'xtended'
	DEFB	'R'+80H         ;71 Required
	DEFM	'equired'
	DEFB	'C'+80H         ;72 Command
	DEFM	'ommand'
	DEFB	'H'+80H         ;73 Hardware
	DEFM	'ardware'
	DEFB	'H'+80H         ;74 Header
	DEFM	'eader'
	DEFB	'P'+80H         ;75 Parity
	DEFM	'arity'
	DEFB	'S'+80H         ;76 System
	DEFM	'ystem'
	DEFB	'D'+80H         ;77 Deleted
	DEFM	'eleted'
	DEFB	'D'+80H         ;78 Device
	DEFM	'evice'
	DEFB	'S'+80H		;79 Sectors
	DEFM	'ectors'
	DEFB	'I'+80H         ;80 In
	DEFM	'n'
	DEFB	'D'+80H         ;81 Devicespec
	DEFM	'evicespec'
	DEFB	'U'+80H         ;82 Use
	DEFM	'se'
	DEFB	'M'+80H         ;83 Modem Carrier
	DEFM	'odem Carrier'
	DEFB	'A'+80H         ;84 Attempted
	DEFM	'ttempted'
	DEFB	'T'+80H         ;85 Transmitter
	DEFM	'ransmitter'
	DEFB	'F'+80H         ;86 Framing
	DEFM	'raming'
	DEFB	'S'+80H         ;87 Serial
	DEFM	'erial'
	DEFB	'L'+80H         ;88 Logical
	DEFM	'ogical'
	DEFB	'C'+80H         ;89 Clear
	DEFM	'lear'
	DEFB	'S'+80H         ;90 Send
	DEFM	'end'
	DEFB	'D'+80H         ;91 Detected
	DEFM	'etected'
	DEFB	'C'+80H         ;92 Channel
	DEFM	'hannel'
	DEFB	'I'+80H         ;93 Input
	DEFM	'nput'
	DEFB	'O'+80H         ;94 Output
	DEFM	'utput'
	DEFB	'I'+80H         ;95 Insufficient
	DEFM	'nsufficient'
	DEFB	'S'+80H         ;96 Set
	DEFM	'et'
	DEFB	'M'+80H         ;97 Member
	DEFM	'ember'
	DEFB	'T'+80H         ;98 Terminated
	DEFM	'erminated'
	DEFB	'A'+80H		;99 Allocated
	DEFM	'llocated'
	DEFB	'E'+80H		;100 Extension
	DEFM	'xtension'
	DEFB	'B'+80H		;101 Before
	DEFM	'efore'
	DEFB	'A'+80H		;102 Any
	DEFM	'ny'
	DEFB	'T'+80H         ;103 Table
	DEFM	'able'
	DEFB	'C'+80H         ;104 Corrupt
	DEFM	'orrupt'
	DEFB	'E'+80H         ;105 Extent
	DEFM	'xtent'
	DEFB	'T'+80H         ;106 Terminator
	DEFM	'erminator'
	DEFB	'L'+80H         ;107 Links
	DEFM	'inks'
	DEFB	'L'+80H         ;108 Linking
	DEFM	'inking'
	DEFB	'B'+80H         ;109 Back
	DEFM	'ack'
	DEFB	'I'+80H         ;110 It
	DEFM	't'
	DEFB	'T'+80H         ;111 Track
	DEFM	'rack'
	DEFB	'A'+80H         ;112 Assigned
	DEFM	'ssigned'
	DEFB	'B'+80H         ;113 Beyond
	DEFM	'eyond'
	DEFB	'B'+80H         ;114 Boundary
	DEFM	'oundary'
	DEFB	'F'+80H         ;115 Forward
	DEFM	'orward'
	DEFB	'L'+80H         ;116 Link
	DEFM	'ink'
	DEFB	'I'+80H         ;117 Inactive
	DEFM	'nactive'
	DEFB	'E'+80H         ;118 Entry
	DEFM	'ntry'
	DEFB	'N'+80H         ;119 Non-extension
	DEFM	'on-extension'
	DEFB	'E'+80H         ;120 Establish
	DEFM	'stablish'
	DEFB	'T'+80H         ;121 Type
	DEFM	'ype'
	DEFB	'U'+80H         ;122 Unknown
	DEFM	'nknown'
	DEFB	'M'+80H		;123 Multiple
	DEFM	'ultiple'
	DEFB	'F'+80H		;124 Files
	DEFM	'iles'
	DEFB	'G'+80H		;125 Granule
	DEFM	'ranule'
	DEFB	'B'+80H		;126 Byte
	DEFM	'yte'
	DEFB	'A'+80H		;127 A Zero
	DEFM	' Zero'
	DEFB	80H
;
; following is the sentence table
; high bit of first word number in sentence is set
; 80H terminates the table
;
TABLE2	EQU	$
	DB	1+80H		;0
	DB	2
	DB	3+80H		;1
	DB	4
	DB	5
	DB	6
	DB	7
	DB	8
	DB	9+80H		;2
	DB	10
	DB	11
	DB	12+80H		;3
	DB	2
	DB	13+80H		;4
	DB	2
	DB	6
	DB	14
	DB	15
	DB	16
	DB	14+80H		;5
	DB	17
	DB	10
	DB	18
	DB	122+80H 	;6
	DB	2
	DB	19+80H		;7
	DB	14
	DB	20
	DB	14+80H		;8
	DB	21
	DB	10
	DB	22
	DB	23+80H		;9
	DB	24
	DB	25
	DB	122+80H 	;10
	DB	2
	DB	26+80H		;11
	DB	27
	DB	28
	DB	1+80H		;12
	DB	21
	DB	11
	DB	29
	DB	30
	DB	26
	DB	32+80H		;13
	DB	33
	DB	29
	DB	31
	DB	34
	DB	26
	DB	32+80H		;14
	DB	35
	DB	6
	DB	14
	DB	15
	DB	32+80H		;15
	DB	36
	DB	14
	DB	37+80H		;16
	DB	38
	DB	39
	DB	40
	DB	41+80H		;17
	DB	31
	DB	2
	DB	41+80H		;18
	DB	32
	DB	2
	DB	23+80H		;19
	DB	42
	DB	43+80H		;20
	DB	31
	DB	2
	DB	43+80H		;21
	DB	32
	DB	2
	DB	44+80H		;22
	DB	31
	DB	2
	DB	44+80H		;23
	DB	32
	DB	2
	DB	26+80H		;24
	DB	10
	DB	18
	DB	26+80H		;25
	DB	45
	DB	46
	DB	41+80H		;26
	DB	47
	DB	48
	DB	14+80H		;27
	DB	47
	DB	48
	DB	49+80H		;28
	DB	50
	DB	26
	DB	51
	DB	52+80H		;29
	DB	53
	DB	54
	DB	50
	DB	55
	DB	41+80H		;30
	DB	47
	DB	48
	DB	56
	DB	57
	DB	26
	DB	58+80H		;31
	DB	10
	DB	18
	DB	23+80H		;32
	DB	59
	DB	122+80H 	;33
	DB	2
	DB	60+80H		;34
	DB	26
	DB	61
	DB	2
	DB	62+80H		;35
	DB	35
	DB	19+80H		;36
	DB	45
	DB	84
	DB	29
	DB	36
	DB	26
	DB	30+80H		;37
	DB	33
	DB	29
	DB	63
	DB	30
	DB	26
	DB	15+80H		;38
	DB	33
	DB	29
	DB	63
	DB	64
	DB	26
	DB	19+80H		;39
	DB	15
	DB	33
	DB	65+80H		;40
	DB	2
	DB	66+80H		;41
	DB	24
	DB	6
	DB	14
	DB	15
	DB	67+80H		;42
	DB	10
	DB	22
	DB	67+80H		;43
	DB	54
	DB	50
	DB	68
	DB	67+80H		;44
	DB	35
	DB	67+80H		;45
	DB	10
	DB	11
	DB	23+80H		;46
	DB	15
	DB	33
	DB	29
	DB	69
	DB	26
	DB	71+80H		;47
	DB	72
	DB	12
	DB	10
	DB	18
	DB	23+80H		;48
	DB	72
	DB	12
	DB	73+80H		;49
	DB	35
	DB	6
	DB	14
	DB	15
	DB	122+80H 	;50
	DB	2
	DB	13+80H		;51
	DB	2
	DB	6
	DB	74
	DB	31
	DB	65+80H		;52
	DB	2
	DB	6
	DB	31
	DB	66+80H		;53
	DB	24
	DB	6
	DB	31
	DB	13+80H		;54
	DB	2
	DB	6
	DB	31
	DB	24+80H		;55
	DB	52
	DB	10
	DB	18
	DB	6
	DB	31
	DB	33+80H		;56
	DB	29
	DB	31
	DB	76
	DB	24
	DB	52
	DB	33+80H		;57
	DB	29
	DB	31
	DB	77
	DB	24
	DB	52
	DB	78+80H		;58
	DB	10
	DB	11
	DB	13+80H		;59
	DB	2
	DB	6
	DB	74
	DB	32
	DB	65+80H		;60
	DB	2
	DB	6
	DB	32
	DB	66+80H		;61
	DB	24
	DB	6
	DB	32
	DB	13+80H		;62
	DB	2
	DB	6
	DB	32
	DB	24+80H		;63
	DB	52
	DB	10
	DB	18
	DB	6
	DB	32
	DB	32+80H		;64
	DB	35
	DB	6
	DB	14
	DB	21
	DB	14+80H		;65
	DB	32
	DB	36
	DB	1+80H		;66
	DB	4
	DB	28
	DB	21+80H		;67
	DB	10
	DB	80
	DB	76
	DB	23+80H		;68
	DB	81
	DB	1+80H		;69
	DB	78
	DB	47
	DB	11
	DB	78+80H		;70
	DB	10
	DB	11
	DB	78+80H		;71
	DB	80
	DB	82
	DB	36+80H		;72
	DB	76
	DB	78
	DB	83+80H		;73
	DB	66
	DB	85+80H		;74
	DB	10
	DB	11
	DB	86+80H		;75
	DB	2
	DB	87+80H		;76
	DB	24
	DB	66
	DB	87+80H		;77
	DB	75
	DB	2
	DB	89+80H		;78
	DB	29
	DB	90
	DB	10
	DB	91
	DB	19+80H		;79
	DB	88
	DB	26
	DB	53
	DB	23+80H		;80
	DB	93
	DB	92
	DB	23+80H		;81
	DB	94
	DB	92
	DB	95+80H		;82
	DB	62
	DB	78+80H		;83
	DB	27
	DB	28
	DB	24+80H		;84
	DB	96
	DB	97
	DB	10
	DB	18
	DB	98+80H		;85
	DB	58+80H		;86
	DB	98
	DB	23+80H		;87
	DB	24
	DB	96
	DB	97
	DB	4+80H		;88
	DB	10
	DB	11
	DB	19+80H		;89
	DB	93
	DB	94
	DB	92
	DB	43+80H		;90
	DB	103
	DB	104
	DB	44+80H		;91
	DB	103
	DB	104
	DB	1+80H		;92
	DB	105
	DB	106
	DB	6
	DB	26
	DB	41+80H		;93
	DB	107
	DB	29
	DB	52
	DB	10
	DB	108
	DB	109
	DB	29
	DB	110
	DB	111+80H 	;94
	DB	112
	DB	113
	DB	14
	DB	114
	DB	115+80H 	;95
	DB	41
	DB	116
	DB	29
	DB	117
	DB	118
	DB	115+80H 	;96
	DB	116
	DB	29
	DB	119
	DB	118
	DB	56+80H		;97
	DB	120
	DB	14
	DB	121
	DB	19+80H 		;98
	DB	24
	DB	55
	DB	49+80H		;99
	DB	50
	DB	26
	DB	17
	DB	113
	DB	99
	DB	79
	DB	100+80H		;100
	DB	112
	DB	101
	DB	49
	DB	50
	DB	105
	DB	100+80H		;101
	DB	52
	DB	10
	DB	112
	DB	29
	DB	102
	DB	26
	DB	123+80H		;102
	DB	124
	DB	112
	DB	29
	DB	125
	DB	41+80H		;103
	DB	52
	DB	38
	DB	63
	DB	23
	DB	44
	DB	126
	DB	41+80H		;104
	DB	52
	DB	38
	DB	127
	DB	44
	DB	126
	DB	70+80H		;105
	DB	41
	DB	52
	DB	38
	DB	63
	DB	23
	DB	44
	DB	126
	DB	70+80H		;106
	DB	41
	DB	52
	DB	38
	DB	127
	DB	44
	DB	126
	DB	80H
;
SYS5BUF DS	80		;work area for messages
;
	PAGE
;
; message text for errors
;
;00 - No Error
;01 - Bad Function Code On SVC Call
;02 - Character Not Available
;03 - Parameter Error
;04 - CRC Error On Disk I/O Operation
;05 - Disk Sector Not Found
;06 - Unknown Error
;07 - Illegal Disk Change
;08 - Disk Drive Not Ready
;09 - Invalid Data Provided
;10 - Unknown Error
;11 - File Already Exists
;12 - No Drive Available To Open File
;13 - Write Attempt To Read Only File
;14 - Write Fault On Disk I/O
;15 - Write Protected Disk
;16 - DCB Has Been Modified
;17 - Directory Read Error
;18 - Directory Write Error
;19 - Invalid Filespec
;20 - GAT Read Error
;21 - GAT Write Error
;22 - HIT Read Error
;23 - HIT Write Error
;24 - File Not Found
;25 - File Access Denied
;26 - Directory Space Full
;27 - Disk Space Full
;28 - End Of File Encountered
;29 - Record Number Out Of Range
;30 - Directory Space Full Cannot Extend File
;31 - Program Not Found
;32 - Invalid Drivespec
;33 - Unknown Error
;34 - Load File Format Error
;35 - Memory Fault
;36 - Unknown Error
;37 - Open Attempt To An Open File
;38 - I/O Attempt To An Unopen File
;39 - Illegal I/O Attempt
;40 - Seek Error
;41 - Lost Data On Disk I/O
;42 - Printer Not Ready
;43 - Printer Out Of Paper
;44 - Printer Fault
;45 - Printer Not Available
;46 - Invalid I/O Attempt To VLR Type File
;47 - Required Command Parameter Not Found
;48 - Invalid Command Parameter
;49 - Hardware Fault On Disk I/O
;50 - Unknown Error
;51 - CRC Error On Header Read
;52 - Seek Error On Read
;53 - Lost Data On Read
;54 - CRC Error On Read
;55 - Data Record Not Found On Read
;56 - Attempt To Read System Data Record
;57 - Attempt To Read Deleted Data Record
;58 - Device Not Available
;59 - CRC Error On Header Write
;60 - Seek Error On Write
;61 - Lost Data On Write
;62 - CRC Error On Write
;63 - Data Record Not Found On Write
;64 - Write Fault On Disk Drive
;65 - Disk Write Protected
;66 - No Function Exists
;67 - Drive Not In System
;68 - Invalid Devicespec
;69 - No Device Space Available
;70 - Device Not Available
;71 - Device In Use
;72 - Protected System Device
;73 - Modem Carrier Lost
;74 - Transmitter Not Available
;75 - Framing Error
;76 - Serial Data Lost
;77 - Serial Parity Error
;78 - Clear To Send Not Detected
;79 - Illegal Logical File Number
;80 - Invalid Input Channel
;81 - Invalid Output Channel
;82 - Insufficient Memory
;83 - Device Already Exists
;84 - Data Set Member Not Found;
;85 - Terminated
;86 - Program Terminated
;87 - Invalid Data Set Member
;88 - Function Not Available
;89 - Illegal Input Output Channel
;90 - GAT Table Corrupt
;91 - HIT Table Corrupt
;92 - No Extent Terminator On File
;93 - Directory Links To Record Not Linking Back To It
;94 - Track Assigned Beyond Disk Boundary
;95 - Forward Directory Link To Inactive Entry
;96 - Forward Link To Non-extension Entry
;97 - Cannot Establish Disk Type
;98 - Illegal Data Range
;99 - End Of File Sector Beyond Allocated Sectors
;100- Extension Assigned Before End Of Extent
;101- Extension Record Not Assigned To Any File
;102- Multiple Files Assigned To Granule
;103- Directory Record Has An Invalid HIT Byte
;104- Directory Record Has A Zero HIT Byte
;105- Extended Directory Record Has An Invalid HIT Byte
;106- Extended Directory Record Has A Zero HIT Byte
;
ZZZZZ	EQU	$
	END	VECTORS
