; dossys8/asm - sjp/mss - kjw/bqsd - 08/82
;
	TITLE	'<Dos+ II.A - SYS08/SYS>'
;
	ORG	1C00H		;low residing
;
;	external support
;
DCHECK	EQU	0		;check drive ready
SREAD	EQU	6		;read system sector
DISKIO	EQU	10H		;DISK I/O MANAGER
;
ERR2	EQU	2		;CHAR NOT AVAILABLE
ERR3	EQU	3		;PARAMETER ERROR
BADF	EQU	1		;bad function code
SVC	EQU	8		;SVC executor
STCMP	EQU	22		;compare strings
PERR	EQU	3		;parameter error
INVF	EQU	19		;invalid filespec
CHNA	EQU	2		;character not avail
;
WILDMSK EQU	017FH		;wild mask storage
REGSAV	EQU	0303H		;save registers
SAVER	EQU	0309H		;save reg & get dcb
DMULT	EQU	0312H		;8 X 16 mult
DDIVD	EQU	0315H		;8 X 16 divide
UCASE	EQU	031EH		;A to upper case
DIRRED	EQU	0324H		;read dir for file
LOCDCT	EQU	032DH		;locate DCT
BUFFER	EQU	1B00H		;main I/O buffer
;
CR	EQU	13		;ASCII EQU
SPACE	EQU	' '
ETX	EQU	3		;end of text
JRC	EQU	38H		;JR C opcode
JRNC	EQU	30H		;JR NC opcode
;
VECTORS DW	RETURN		;0 - return
	DW	PARSER		;1
	DW	WILD		;2
	DW	RAMDIR		;3
	DW	UNDEF		;4 - $RDDIR
	DW	FILPTR		;5
	DW	DISKID		;6
	DW	SORT		;7
	DW	SORT2		;8
	DW	UNDEF		;9 - undefined
	DW	UNDEF		;10
	DW	UNDEF		;11
	DW	UNDEF		;12
	DW	UNDEF		;13
	DW	UNDEF		;14
	DW	UNDEF		;15
;
;	undefined system call
;
UNDEF	LD	A,BADF		;'bad function call'
	OR	A		;set NZ
	RET			;back to caller
;
	PAGE
;
;	$PARSER - GENERAL PURPOSE PARSING
;
;	ENT	 C =	MAX PARSE LENGTH
;		HL =>	TEXT BUFFER
;		DE =>	LIST ADDRESS BLOCK (0=NONE)
;
;	EXT	 A =	CHAR PRECEDING FIELD
;		 B =	ACTUAL FIELD LENGTH
;		 C =	NUMBER OF BYTES REMAINING
;		 D =	FIELD TERMINATOR
;		 E =	DISPLACEMENT POINTER
;		HL =>	FIELD POSITION
;
;		Z SET IF ENDED W/SEPERATOR
;		C SET IF TRAILING BLANKS
;
PARSER	CALL	SETBLK		;SET-UP LIST BLOCKS
	XOR	A		;INIT FLAGS
	PUSH	AF		;FLAGS TO STACK
	LD	E,A		;DISP POINTER
	LD	B,A		;FIELD LENGTH
	DEC	A		;-1
	LD	(TCHR),A	;TERM CHAR
	LD	(PCHR),A	;PREVIOUS CHAR
	DEC	HL		;BKSP TEXT
	EX	(SP),HL 	;HL = FLAGS
;
;	CHECK FOR END PARSING
;
PARS1	EX	(SP),HL 	;HL => TEXT BUFFER
	INC	HL		;NEXT
	INC	C
	CP	C		;END PARSE?
	JR	NZ,PARS2	;IF NOT
	EX	(SP),HL 	;GET FLAGS
	RES	6,L		;TERM FOUND - NZ
	JR	PARS12		;SKIP OUT
;
;	GET CHAR FROM TEXT
;
PARS2	LD	A,(HL)		;GET CHAR
	DEC	C		;DEC COUNT
	EX	(SP),HL 	;HL = FLAGS
	BIT	7,H		;IN FIELD?
	JR	Z,PARS3 	;IF NOT
	INC	E		;DISP POINTER
;
;	CHECK FOR END LITERAL
;
PARS3	BIT	5,H		;IN LITERAL?
	JR	Z,PARS4 	;IF NOT
	CP	D		;TERM LITERAL?
	JR	NZ,PARS7	;IF NOT
	RES	5,H		;NO LITERAL
	SET	6,H		;END FIELD
	JR	PARS1		;TRY AGAIN
;
;	CHECK FOR START LITERAL
;
PARS4	CP	'"'             ;LITERAL?
	JR	Z,PARS5 	;SKIP
	CP	27H		;literal?
	JR	NZ,PARS6	;IF NOT
;
PARS5	BIT	7,H		;IN FIELD?
	JR	NZ,PARS11	;IF NOT
	SET	5,H		;IN LITERAL
	LD	D,A		;LITERAL CHAR
	JR	PARS1		;TRY AGAIN
;
;	CHECK FOR START FIELD
;
PARS6	CALL	CKCHR		;CHECK CHARACTER
	JR	NZ,PARS9	;TERM/SEPERATOR
PARS7	BIT	7,H		;IN FIELD?
	JR	NZ,PARS8	;IF YES
	INC	E		;DISPLACEMENT POINTER
	EX	(SP),HL 	;HL => TEXT BUFFER
	DEC	HL		;BKSP
	LD	A,(HL)		;GET CHAR
	LD	(PCHR),A	;SET PRECEDING CHAR
	INC	HL		;CORRECT
	LD	(FPOS),HL	;SAVE
	EX	(SP),HL 	;GET FLAGS
	SET	7,H		;HAVE FIELD
;
;	CHECK FOR END FIELD
;
PARS8	BIT	6,H		;END FIELD?
	JR	Z,PARSA 	;IF NOT
	DEC	E		;DISPLACEMENT POINTER
	INC	C		;PARSE COUNT
	JR	PARS12		;EXIT
;
PARSA	INC	B		;ACTUAL FIELD LENGTH
	JR	PARS1		;TRY AGAIN
;
;	SKIP TRAILING BLANKS
;
PARS9	JR	C,PARS10	;IF TERMINATOR
	CP	' '             ;BLANK?
	JR	NZ,PARS11	;IF NOT
	BIT	7,H		;IN FIELD?
	JR	Z,PARS1 	;IF NOT
	SET	6,H		;END FIELD
	SET	0,L		;TRAIL BLANKS - C
	JR	PARS1		;TRY AGAIN
;
;	END OF FIELD PROCESSING
;
PARS10	RES	6,L		;TERM FOUND - NZ
PARS11	LD	(TCHR),A	;SET TERM CHAR
	BIT	7,H		;IN FIELD?
	JR	NZ,PARS12	;IF YES
	INC	E		;DISPLACEMENT POINTER
	EX	(SP),HL 	;GET TEXT BUFFER
	LD	(FPOS),HL	;SET FIELD POSN
	EX	(SP),HL 	;GET FLAGS
;
PARS12	EX	(SP),HL 	;GET TEXT BUFFER
	LD	HL,(FPOS)	;HL => FIELD POSN
	POP	AF		;GET FLAGS
	LD	A,(TCHR)	;TERM CHAR
	LD	D,A		;D = TERM CHAR
	LD	A,(PCHR)	;PREVIOUS CHAR
	RET
;
;	VARIABLES FOR PARSER
;
FPOS	DEFS	2		;FIELD POSN
TCHR	DEFS	1		;TERM CHAR
PCHR	DEFS	1		;PREVIOUS CHAR
;
	PAGE
;	CHECK IF CHAR FIELD/TERM/SEPERATOR
;
;	ENT	 A =	CHARACTER
;
;	EXT	 Z & NC IF FIELD
;		 NZ & C  IF TERMINATOR
;		 NZ & NC IF SEPERATOR
;
CKCHR	PUSH	HL		;SAVE REG
	PUSH	BC
	LD	B,0		;MSB COUNT
;
;	CHECK FOR SPECIAL TERMINATOR
;
CKCHR1	LD	HL,(LIST1)	;TERM LIST
	LD	C,(HL)		;CHAR COUNT
	INC	C
	DEC	C		;NULL?
	JR	Z,CKCHR2	;SKIP
	INC	HL		;HL => LIST
	CPIR			;FOUND?
	JR	Z,CKCHR7	;TERMINATOR
;
;	CHECK FOR SPECIAL FIELD CHAR
;
CKCHR2	LD	HL,(LIST2)	;FIELD LIST
	LD	C,(HL)		;CHAR COUNT
	INC	C
	DEC	C		;NULL?
	JR	Z,CKCHR3	;SKIP
	INC	HL		;HL => LIST
	CPIR			;FOUND?
	JR	Z,CKCHR5	;FIELD CHAR
;
;	CHECK DEFAULT FIELD CHAR
;
CKCHR3	CP	'0'             ;NUMERIC?
	JR	C,CKCHR6	;SEPERATOR
	CP	'9'+1           ;NUMERIC?
	JR	C,CKCHR4	;FIELD
	CP	'A'             ;ALPHA?
	JR	C,CKCHR6	;SEPERATOR
	CP	'Z'+1           ;ALPHA?
	JR	C,CKCHR4	;FIELD
	CP	'a'             ;ALPHA?
	JR	C,CKCHR6	;SEPERATOR
	CP	'z'+1           ;ALPHA?
	JR	NC,CKCHR6	;SEPERATOR
;
;	CHECK FOR SPECIAL SEPERATOR
;
CKCHR4	LD	HL,(LIST3)	;FIELD LIST
	LD	C,(HL)		;CHAR COUNT
	INC	C
	DEC	C		;NULL?
	JR	Z,CKCHR5	;SKIP
	INC	HL		;HL => LIST
	CPIR			;FOUND?
	JR	Z,CKCHR6	;TERMINATOR
;
;	SET-UP TERMINATING STATUS
;
CKCHR5	CP	A		;Z & NC
	JR	CKCHR8		;SKIP W/FIELD
CKCHR6	LD	B,A		;SAVE CHAR
	OR	-1		;NZ & NC
	LD	A,B		;GET CHAR
	JR	CKCHR8		;SKIP W/SEPRATOR
CKCHR7	LD	B,A		;SAVE CHAR
	OR	-1		;NZ & NC
	SCF			;NZ & C
	LD	A,B		;GET TERM CHAR
CKCHR8	POP	BC		;RESTORE REG
	POP	HL
	RET
;
	PAGE
;	SET-UP LIST-BLOCK ROUTINE
;
;	ENT	DE =>	LIST ADD BLOCK (0=DEFAULT)
;
SETBLK	PUSH	HL		;SAVE
	LD	A,D
	OR	A		;NO LISTS?
	JR	NZ,$+5		;IF NOT
	LD	DE,DEFLBA	;DE => DEFAULT LIST
	CALL	GETBLK		;GET BLOCK ADD
	LD	(LIST1),HL	;SET LIST 1
	CALL	GETBLK		;GET BLOCK ADD
	LD	(LIST2),HL	;SET LIST 2
	CALL	GETBLK		;GET BLOCK ADD
	LD	(LIST3),HL	;SET LIST 3
	POP	HL		;RESTORE
	RET
;
;	GET LIST FROM LIST BLOCK
;
;	ENT	DE =>	LIST BLOCK
;
GETBLK	EX	DE,HL		;HL => LIST ADDRESS BLOCK
	LD	E,(HL)
	INC	HL
	LD	D,(HL)		;DE => LIST BLOCK
	INC	HL
	EX	DE,HL		;HL => LIST BLOCK
	LD	A,H
	OR	L		;LIST BLOCK 0?
	RET	NZ		;IF NOT
	LD	HL,NULL 	;NULL LIST
	RET
;
;	DEFAULT LIST BLOCKS
;
DEFLBA	DEFW	0		;DEFAULT TERM BLOCK
	DEFW	0		;DEFAULT FIELD BLOCK
	DEFW	0		;DEFAULT SEPR BLOCK
;
NULL	DEFB	0		;DEFAULT LIST-BLOCK
;
;	LIST BLOCK ADDRESSES
;
LIST1	DEFW	0		;TERMINATOR LIST
LIST2	DEFW	0		;FIELD LIST
LIST3	DEFW	0		;SEPERATOR LIST
;
	PAGE
;
;	$WILD	- SVC 51 - setup/compare wildmask
;
;	B = function code
;
;	ENT	B = 0	- set wild card mask
;		HL => wildmask
;	EXT	Z = OK
;		NZ = invalid mask spec
;
;	ENT	B = 1	- compare filespec with mask
;		HL => filespec to compare
;	EXT	Z = OK, match
;		NZ = file does not match mask
;
;	ENT	B = 2	- combine name/ext into filespec
;		HL => 11 byte buffer (NAME   EXT) padded
;		DE => 13 byte buffer to hold filespec
;	EXT	Z = OK
;		NZ = invalid filespec chars
;
;	ENT	B = 3	- compare cracked with mask
;		HL => cracked filespec to compare
;	EXT	Z = match
;		NZ = NO match
;
WILD	CALL	REGSAV		;save registers
	XOR	A		;check command
	CP	B		;B = 0?
	JR	Z,WILD0 	;set mask
;
	DEC	B		;B = 1?
	JP	Z,WILD1 	;compare file>mask
;
	DEC	B		;B = 2?
	JR	Z,WILD2 	;un-crack filespec
;
	DEC	B		;B = 3?
	LD	A,BADF		;bad function call
	RET	NZ		;error, return
	JP	WILD3		;compare
;
;	combine name and ext into filespec
;
WILD2	LD	B,8		;move 8 chars
	CALL	WILD2M		;move 'em
	RET	NZ		;invalid chars
;
;	check for extension
;
	LD	A,(HL)		;get next char
	CP	SPACE		;separator?
	JR	Z,WILD2D	;done if yes
;
;	exists, insert an extension marker
;
	LD	A,'/'           ;extension mark
	LD	(DE),A		;put in buffer
	INC	DE		;bump pointer
;
	LD	B,3		;move 3 chars
	CALL	WILD2M		;move 'em
	RET	NZ		;invalid chars
;
;	completed, insert ETX
;
WILD2D	LD	A,ETX		;insert a CR
	LD	(DE),A		;put it in
;
RETURN	XOR	A		;return Z
	RET			;done
;
;	move chars from HL => DE
;
WILD2M	LD	A,(HL)		;get a char
	CP	SPACE		;space?
	JR	Z,WILD2N	;next char if yes
;
;	check for valid char
;
	CALL	VALCHR		;is it?
	JR	Z,WILD2B	;error, invalid char
	LD	(DE),A		;valid, put in buffer
;
	INC	DE		;bump dest
WILD2N	INC	HL		;bump source
	DJNZ	WILD2M		;check next one
;
	XOR	A		;set Z for OK
	RET			;done
;
;	invalid chars
;
WILD2B	LD	A,INVF		;'invalid filespec'
	OR	A		;set NZ
	RET			;done, go back
;
;	set wildmask
;
WILD0	PUSH	HL		;save string pointer
	LD	HL,WILDMSK	;sys0 mask
	PUSH	HL		;save for DE
	LD	D,H		;pass to DE
	LD	E,L
	INC	DE		;DE = HL+1
	LD	BC,10		;11 byte field
	LD	(HL),'?'        ;set to nil
	LDIR			;nil the mask
;
	POP	DE		;DE => wildmask
	POP	HL		;HL => user mask
;
	LD	B,8		;8 chars in name
	CALL	WILD0M		;move it in
	JR	Z,WILD0E	;OK, continue
	CP	'/'             ;this the bad char?
	JR	NZ,WILD2B	;nope, go error
;
WILD0E	LD	B,3		;3 char extension
	CALL	WILD0M		;move it in
	JR	NZ,WILD2B	;nope, error
;
	XOR	A		;else for zero
	RET			;done
;
;	move chars into wildmask field
;
WILD0M	LD	A,(HL)		;fetch a char
	CALL	CKTERM		;terminator?
	JR	C,WILD0T	;terminator, continue
;
	CALL	VALCHR		;valid character?
	JR	Z,WILD0B	;nope, check for error
;
	CP	'*'             ;wild card filler?
	JR	Z,WILD0F	;fill it up if yes
	CP	'!'		;wild card filler?
	JR	Z,WILD0F	;yes, fill it up
;
	CALL	UCASE		;force upper case
	LD	(DE),A		;else put in wildmask
	INC	DE		;bump pointers
	INC	HL
	DJNZ	WILD0M		;go more
	LD	A,(HL)
	CP	'/'
	JR	NZ,WILD0R
	INC	HL
;
WILD0R	XOR	A		;set Z flag
	RET			;done
;
;	fill remainder of field with blanks
;
WILD0F	LD	A,'?'           ;use to fill
	CALL	WILD0FS 	;fill it up
	LD	A,(HL)		;fetch it back
	CP	'!'		;special filler?
	RET	Z		;yes, return
	INC	HL		;get next char
	LD	A,(HL)		;fetch it
	CALL	CKTERM		;terminator?
	RET	C		;yes, return
	JR	WILD0B		;else generate error
;
WILD0FS INC	B		;done with field?
	DEC	B
;
WILD0FF JR	Z,WILD0R	;return if yes
	LD	(DE),A		;put in char
	INC	DE		;bump pointer
	DEC	B		;less counter
	JR	WILD0FF 	;fill more?
;
WILD0B	CP	'/'             ;offending char?
	INC	HL		;bump pointer
	RET	NZ		;nope, error
WILD0T	LD	A,20H		;use to fill
	JR	WILD0FS 	;fill rest of field
;
;	compare filespec to mask
;
WILD3	LD	DE,WILDMSK	;sys0 mask area
	LD	B,11		;11 chars to compare
;
WILD3L	LD	A,(DE)		;get a char
	CP	'?'             ;wild char?
	JR	Z,WILD3N	;force a match
	CP	(HL)		;same one?
	JR	NZ,WILD3R	;nope, return
;
WILD3N	INC	HL		;bump pointers
	INC	DE
	DJNZ	WILD3L		;check next one
;
	XOR	A		;done, return with Z
	JR	WILD3R+2	;continue
;
WILD3R	LD	A,2		;'not available'
	OR	A		;set flags
	RET			;done
;
WILD1	EX	DE,HL		;DE => filename
	LD	HL,NAME 	;buffer
	PUSH	HL		;save pointer
	CALL	CRACK		;open it up
	POP	HL		;get pointer
	JP	WILD3		;compare it now
;
;	crack open filespec
;
CRACK	LD	B,11		;11 chars to fill
	PUSH	HL		;save start
CRACK1	LD	(HL),20H	;set nil
	INC	HL
	DJNZ	CRACK1		;fill more
	POP	HL		;get pointer back
;
	EX	DE,HL		;HL => filespec
	LD	B,8		;8 chars in name
	CALL	GETFLD		;get the field
	LD	C,A		;save term char
	LD	A,B		;get length
	CP	8		;anything?
	JR	NZ,CRACK2	;go if not
CRACKN	LD	A,CHNA		;char not available
	OR	A		;set NZ
	RET
;
CRACK2	LD	A,C		;get term
	CP	'/'             ;extension?
	JR	Z,CRACK3	;yes, go
	XOR	A		;else done
	RET
;
CRACK3	LD	B,3		;3 chars to move
	LD	DE,NAME+8	;extension field
	CALL	GETFLD		;get the field
	LD	A,B
	CP	3		;nil?
	JR	Z,CRACKN	;no good
	XOR	A		;else done
	RET
;
GETFLD	LD	A,(HL)		;get a character
	CALL	VALCHR		;valid?
	INC	HL		;bump pointer
	RET	Z		;no, return
	CALL	UCASE		;make it upper
	LD	(DE),A		;put in buffer
	INC	DE		;bump pointer
	DJNZ	GETFLD		;go more
;
	LD	A,(HL)		;get term char
	INC	HL
	RET			;done
;
	PAGE
;
;	$VALCHR - check for valid filespec char
;
;	EXT	Z = invalid
;		NZ = OK
;
VALCHR	PUSH	HL		;save registers
	PUSH	BC
	LD	HL,CHRTBL	;invalid char table
	LD	BC,16		;16 reserved chars
	CPIR			;find!
	POP	BC		;unstack
	POP	HL
	RET			;done
;
;	table of reserved chars
;
CHRTBL	DEFM	'('
	DEFM	')'
	DEFM	','
	DEFM	'.'
	DEFM	'/'
	DEFM	';'
	DEFM	' '
	DEFM	':'
	DEFM	'@'
	DEFM	'='
	DEFM	'"'
	DEFB	27H
	DEFB	ETX
	DEFB	CR
	DEFB	7BH
	DEFB	7DH
;
;	$CKTERM - check for terminator
;
;	EXT	Carry = terminator
;
CKTERM	CP	CR
	SCF
	RET	Z
	CP	';'
	SCF
	RET	Z
	CP	ETX
	SCF
	RET	Z
	OR	A
	RET
;
NAME	DS	11		;work area for WILD
;
	PAGE
;
;	$SORT	- SORT MEMORY BLOCK
;
;	ENT	IX =>	FIRST ENTRY IN LIST
;		DE =>	LAST ENTRY IN LIST
;		 B =	POSITION OF KEY
;		 C =	LENGTH OF EACH ENTRY
;		 L =	LENGTH OF SORT KEY
;		 H =	SORT FLAG - 0=ASCENDING
;
;	$SORT2	- SORT MEMORY BLOCK
;
;	ENT	DE =	LIST LENGTH
;
SORT	CALL	REGSAV		;SAVE REGISTERS
	CALL	NUMENT		;DE = ENTRY COUNT
	JR	$+5		;SKIP
;
SORT2	CALL	REGSAV		;SAVE REGISTERS
	CALL	SETSORT 	;SET-UP SORT PARAMS
	RET	NZ		;IF ERROR
;
;	CHECK FOR COMPLETION
;
SORT1	LD	HL,(GAP)	;GAP
	LD	A,H
	OR	L		;DONE?
	RET	Z		;EXIT
;
;	INITIALIZE SORT PASS
;
SORT9	LD	HL,(CNT)	;ELEMENT COUNT
	LD	DE,(GAP)	;CURRENT GAP
	SBC	HL,DE		;HL = END PASS
	LD	(END),HL	;SAVE IT
	SBC	HL,HL		;ZERO
	LD	(TOP),HL	;TOP ELEMENT
;
SORT8	LD	HL,(TOP)	;TOP PASS
	LD	(LOC),HL	;CURRENT LOC
;
;	PICK-UP NEXT ELEMENTS
;
SORT3	LD	HL,(LOC)	;CURRENT LOC
	LD	DE,(GAP)	;OFFSET
	CALL	POSE		;POSN TO ELEMENTS
;
;	COMPARE ARRAY ELEMENTS
;
SORT4	CALL	CPAIR		;COMPARE ELEMENTS
	JR	Z,SORT7
SRTDIR	EQU	$
	JR	C,SORT7 	;1ST < 2ND
;
;	SWAP ARRAY ELEMENTS
;
	LD	A,(ENTLEN)	;SORT ENTRY
	LD	B,A		;B = LENGTH
SORT5	LD	A,(DE)		;A = 2ND
	LD	C,(HL)		;C = 1ST
	LD	(HL),A		;1ST = 2ND
	LD	A,C		;TEMP
	LD	(DE),A		;2ND = 1ST
	INC	HL		;NEXT
	INC	DE		;NEXT
	DJNZ	SORT5		;TIL SWAPPED
;
SORT6	LD	HL,(LOC)	;CURRENT LOC
	LD	DE,(GAP)	;SHELL GAP
	OR	A		;CLR CRY
	SBC	HL,DE		;HL = NEW LOC
	JR	C,SORT7 	;IF NOT
	LD	(LOC),HL	;SET LOC
	JR	SORT3		;START AGAIN
;
;	ADVANCE TO NEXT ELEMENT
;
SORT7	LD	HL,(TOP)	;CURRENT TOP
	INC	HL		;NEXT
	LD	(TOP),HL	;NEW TOP
;
	LD	DE,(END)	;LAST ELEMENT
	OR	A		;CLR CRY
	SBC	HL,DE		;COMPARE
	JR	C,SORT8 	;IF NOT
;
	LD	HL,(GAP)	;CURRENT GAP
	SRL	H
	RR	L		;/ 2
	LD	(GAP),HL	;NEW GAP
	JP	SORT1		;TIL DONE
;
;	SUBROUTINE TO POSN ELEMENT
;
;	ENT	HL =	SUBSCRIPT
;		DE =	SHELL GAP
;
;	EXT	BC =	TYPE FLAGS
;		HL =>	1ST ELEMENT
;		DE =>	2ND ELEMENT
;
POSE	PUSH	HL		;SAVE LOC
	CALL	POS1		;POSN TO LOC
	EX	(SP),HL 	;HL => LOC
	ADD	HL,DE		;HL => 2ND LOC
	CALL	POS1		;POSN TO ELEMENT
	EX	DE,HL		;DE => 2ND ELEMENT
	POP	HL		;HL => 1ST ELEMENT
	RET
;
POS1	PUSH	DE		;SAVE
	LD	A,(ENTLEN)	;ENTRY LENGTH
	CALL	DMULT		;LENGTH * ENTRY
	LD	E,A
	LD	D,L		;DE = OFFSET
	PUSH	IX
	ADD	IX,DE		;IX => ENTRY
	PUSH	IX
	POP	HL		;HL => ENTRY
	POP	IX		;RESTORE
	POP	DE
	RET
;
;	ROUTINE TO COMPARE ELEMENTS
;
;	ENT	HL =>	1ST ELEMENT
;		DE =>	2ND ELEMENT
;
;	EXT	 C SET IF 1ST < 2ND
;		 Z SET IF 1ST = 2ND
;
CPAIR	PUSH	DE		;SAVE REG
	PUSH	HL
	LD	A,(SRTOFF)	;SORT KEY OFFSET
	LD	C,A
	LD	B,0		;BC = OFFSET
	ADD	HL,BC		;HL => 1ST KEY
	EX	DE,HL
	ADD	HL,BC		;HL => 2ND KEY
	LD	A,(SRTLEN)	;SORT KEY LENGTH
	LD	B,A		;COUNT
CPIR1	LD	A,(DE)		;GET 2ND
	CP	(HL)		;COMPARE
	JR	NZ,CPIR2	;NO MATCH
	INC	DE		;NEXT
	INC	HL		;NEXT
	DJNZ	CPIR1		;TIL DONE
CPIR2	POP	HL		;RERSTORE REG
	POP	DE
	RET
;
;	COMPUTE # ENTRIES TO SORT
;
NUMENT	PUSH	HL		;SAVE
	PUSH	IX
	POP	HL		;HL => START LIST
	EX	DE,HL		;DE => START LIST
	OR	A
	SBC	HL,DE		;HL = SORT SPACE
	LD	A,C		;ENTRY LENGTH
	CALL	DDIVD		;SPACE/LENGTH
	EX	DE,HL		;DE = ENTRY COUNT
	POP	HL		;RESTORE
	INC	DE		;CORRECT
	RET
;
;	SET-UP SORT PARAMETERS
;
SETSORT CALL	PARSORT 	;CHECK PARAMETERS
	OR	A		;ERROR CODE?
	RET	NZ		;IF ERROR
;
	LD	(CNT),DE	;KEY COUNT
	SRL	D
	RR	E		;/ 2
	LD	(GAP),DE	;INIT GAP
;
	LD	A,L
	LD	(SRTLEN),A	;SET KEY LENGTH
	LD	A,B
	LD	(SRTOFF),A	;SET KEY OFFSET
	LD	A,C
	LD	(ENTLEN),A	;SET ENTRY LENGTH
;
	LD	A,JRC		;ASSUME ASCENDING
	INC	H
	DEC	H		;IS IT?
	JR	Z,$+4		;IF YES
	LD	A,JRNC		;IF NOT
	LD	(SRTDIR),A	;SET DIRECTION
	XOR	A		;NO ERROR
	RET
;
;	CHECK FOR VALID PARAMETERS
;
PARSORT LD	A,L		;sort field length
	OR	A		;0 ?
	LD	A,4		;invalid code
	RET	Z		;invalid
;
	LD	A,C		;entry length
	OR	A		;0 ?
	LD	A,3		;invalid code
	RET	Z		;invalid
;
	LD	A,B		;key posit
	CP	C		;entry length
	LD	A,2		;invalid code
	RET	NC		;invalid
;
	LD	A,L		;sort length
	ADD	A,B		;add key offset
	DEC	A		;adjust for compare
	CP	C		;key st+len <= ent len
	LD	A,1		;error code
	RET	NC		;invalid
;
	LD	A,D		;see if nil length
	OR	E
	LD	A,5		;error code
	RET	Z		;invalid
	XOR	A		;all OK
	RET
;
;	MISC SORT VARIABLES
;
SRTOFF	DEFS	1
SRTLEN	DEFS	1
KEYLEN	DEFS	1
ENTLEN	DEFS	1
;
CNT	DEFS	2
LOC	DEFS	2
GAP	DEFS	2
TOP	DEFS	2
END	DEFS	2
;
	PAGE
;
;	$DISKID - READ DISKETTE ID
;
;	ENT	 B =	DRIVE NUMBER
;		HL =>	I/O BUFFER
;
DISKID	CALL	REGSAV		;SAVE REGISTERS
	EX	DE,HL		;DE => BUFFER
	LD	C,B		;C = DRIVE
	INC	B		;GLOBAL?
	JR	NZ,DSKID2	;IF NOT
	LD	C,B		;START
;
DSKID1	CALL	DSKID2		;READ ID
	RET	NZ		;IF ERROR
	LD	A,7		;LAST DRIVE
	INC	C
	CP	C		;DONE?
	JR	NC,DSKID1	;TIL DONE
	XOR	A		;NO ERROR
	RET
;
;	FETCH DISK NAME
;
DSKID2	LD	A,DCHECK	;CHECK DRIVE
	RST	DISKIO		;DO IT!
	JR	NZ,DSKID3	;NOT READY
	LD	E,0
	LD	B,D		;BE = SECTOR
	LD	HL,BUFFER	;I/O BUFFER
	LD	A,SREAD 	;SYSTEM READ
	RST	SVC		;DO IT!
	RET	NZ		;I/O ERROR
	PUSH	BC		;SAVE DRIVE
	LD	HL,BUFFER+0C0H	;NAME OFFSET
	LD	BC,8		;COUNT
	LDIR			;MOVE!
	POP	BC		;GET DRIVE
	RET
;
;	DUMMY DISK NAME - BLANKS
;
DSKID3	LD	B,8		;COUNT
	LD	A,' '           ;BLANK
DSKID4	LD	(DE),A		;TO BUFF
	INC	DE		;NEXT
	DJNZ	DSKID4		;TIL DONE
	XOR	A		;NO ERROR
	RET
;
;	$FILPTR - GET FILE POINTERS
;
;	ENT	DE =>	OPEN FILE DCB
;
FILPTR	CALL	SAVER		;CHECK & GET DCB
	LD	B,(IX+16)	;B = DRIVE
	LD	C,(IX+17)	;C = LFN/DEC
	RET
;
;	$RAMDIR - RAM DIRECTORY ROUTINE
;
RAMDIR	CALL	REGSAV		;SAVE REGISTERS
	EX	DE,HL		;DE => BUFFER
	PUSH	DE		;pass also to IX
	POP	IX
	LD	A,C
	LD	C,B		;C = DRIVE
	LD	B,A		;B = LFN
	INC	B
	JP	Z,RAMFRE	;GET FREE SPACE
	DEC	B
	JR	NZ,RAMDR3	;GET SPECIFIED RECORD
;
	LD	HL,BUFFER	;I/O BUFFER
	LD	E,2
	LD	B,0		;BE = SECTOR
;
RAMDR1	LD	A,SREAD 	;SYSTEM READ
	RST	DISKIO		;DO IT!
	RET	NZ		;I/O ERROR
RAMDR2	CALL	RAMDR4		;CONVERT RECORD
	LD	A,20H
	ADD	A,L
	LD	L,A		;HL => NEXT ENTRY
	JR	NC,RAMDR2	;WITHIN SECTOR
	CALL	LOCDCT		;LOCATE DCT
	LD	A,(IY+18)	;DIRECTORY LENGTH
	DEC	A		;LAST SECTOR
	INC	E		;NEXT
	CP	E		;DONE?
	JR	NC,RAMDR1	;IF NOT
	LD	A,'#'           ;END LIST
	LD	(IX),A		;TO BUFF
	XOR	A		;NO ERROR
	RET
;
;	READ DIRECTORY FOR FILE
;
RAMDR3	CALL	DIRRED		;READ FILE RECORD
	RET	NZ		;IF ERROR
;
;	GET FILE INFORMATION
;
RAMDR4	PUSH	BC		;SAVE REGISTERS
	PUSH	DE		;save sector
	PUSH	HL
	PUSH	IX		;pass pointer to DE
	POP	DE		;DE => user buffer
;
;	check for active file
;
	BIT	4,(HL)		;active ?
	JP	Z,RAMDR7A	;nope, go!
	BIT	7,(HL)		;extension?
	JP	NZ,RAMDR7A	;yes, go!
;
	LD	A,':'           ;START RECORD
	LD	(DE),A		;TO BUFF
	INC	DE		;NEXT
	LD	A,5		;offset to name
	ADD	A,L
	LD	L,A		;HL => CRACKED NAME
	LD	B,2		;MAKE NAME
	CALL	WILD		;DO IT!
	JP	NZ,RAMDR7	;IF ERROR
	LD	B,15		;COUNT
RAMDR5	LD	A,(DE)		;GET CHAR
	CP	03		;END NAME?
	JR	Z,RAMDR6	;put in blanks
	INC	DE		;bump pointer
	DJNZ	RAMDR5		;TIL END NAME
;
RAMDR6	LD	A,':'		;drive marker
	LD	(DE),A		;to the buffer
	INC	DE		;bump pointer
	LD	A,C		;get drive number
	ADD	A,'0'		;add ascii
	LD	(DE),A		;to the buffer
	INC	DE		;bump it
	LD	A,CR		;insert terminator
	LD	(DE),A		;to the buffer
	INC	DE		;bump pointer
	DEC	B		;less :
	DEC	B		;less drive #
	DEC	B		;less CR
	JR	Z,RAMDR6C	;nothing to pad!
	LD	A,' '		;pad with spaces
RAMDR6D	LD	(DE),A		;put in buffer
	INC	DE		;bump pointer
	DJNZ	RAMDR6D		;continue
;
;	insert FIXED
;
RAMDR6C	LD	A,'F'		;always fixed
	LD	(DE),A		;to the buffer
	INC	DE		;bump pointer
;
;	insert LRL
;
	LD	A,L		;get LSB pointer
	AND	0E0H		;start of name
	ADD	A,4		;LRL byte
	LD	L,A		;HL => it
	LD	A,(HL)		;get LRL
	LD	(DE),A		;to the buffer
	INC	DE		;bump pointer
;
;	dummy insert zeroes for +19-22
;
	EX	DE,HL		;HL => user buffer
	LD	(HL),0		;# extents
	INC	HL
	LD	(HL),0		;# sectors allocated
	INC	HL
	LD	(HL),0
	INC	HL
;
	INC	HL		;pass over sectors used
	INC	HL
;
;	insert EOF byte
;
	DEC	E		;+3
	LD	A,(DE)		;get it
	LD	(HL),A		;to user buffer
	INC	HL		;bump buffer
;
	LD	A,E		;get LSB pointer
	AND	0E0H		;reset to beginning
	ADD	A,20		;offset to EOF
	LD	E,A		;DE => EOF pair
	LD	A,(DE)		;get LSB
	LD	(IX+22),A	;to the buffer
	INC	HL
	INC	E
	LD	A,(DE)		;get MSB EOF
	LD	(IX+23),A
	INC	HL
;
	LD	(HL),0		;user attribute byte
	INC	HL
;
;	insert protection level
;
	LD	A,E		;get LSB file pointer
	AND	0E0H		;to beginning of entry
	LD	E,A		;DE => first byte
	LD	A,(DE)		;get prot level
	AND	7		;low 3 bits only
	LD	(HL),A		;to the buffer
	INC	HL		;bump pointer
;
;	insert DATE
;
	LD	B,2		;2 rounds of dates
	LD	A,E		;get LSB dir pointer
	AND	0E0H		;to beginning
	ADD	A,2		;offset to flags 3
	LD	E,A		;DE => flags 3
RMDATE	LD	A,(DE)		;get flag
	RLCA			;move year to low bits
	RLCA
	RLCA
	AND	7		;8 year range
	ADD	A,80		;offset to 1980
	LD	(HL),A		;put in buffer
	INC	HL		;bump pointer
	DEC	E		;point to flags 2
	LD	A,(DE)		;get month
	AND	0FH		;low 4 bits
	LD	(HL),A		;to the buffer
	INC	HL		;bump pointer
	INC	E		;point to flags 3
	LD	A,(DE)		;get day of month
	AND	1FH		;low 5 bits
	LD	(HL),A		;to the buffer
	INC	HL		;bump pointer
	DJNZ	RMDATE		;do second year
;
;	advance buffer pointer
;
	LD	DE,34		;length of each entry
	ADD	IX,DE		;IX => next entry
;
RAMDR7A	XOR	A		;return ZERO
RAMDR7	POP	HL		;RESTORE REG
	POP	DE		;restore sector
	POP	BC
	RET
;
;	GET FREE SPACE INFORMATION
;
RAMFRE	LD	HL,BUFFER	;I/O buffer
	LD	E,0		;GAT sector
	LD	B,E		;extended sector
	LD	A,SREAD		;system read
	RST	DISKIO		;read the disk
	RET	NZ		;error, return!
;
	CALL	LOCDCT		;load IY with DCT
	LD	B,(IY+16)	;get # cylinders
;
	LD	DE,0		;starting free grans
RAMGN1	LD	C,(IY+21)	;grans/cylinder
	LD	A,(HL)		;get a GAT byte
RAMGN2	RRA			;shift out a bit
	CALL	NC,INCDE	;count off bits
	DEC	C		;less this gran
	JR	NZ,RAMGN2	;finish this track
	DJNZ	RAMGN1		;finish all tracks
;
;	insert # free grans
;
	LD	(IX),E		;# grans LSB
	LD	(IX+1),D	;# grans MSB
;
;	ignore # extents
;
	LD	A,1		;load with one
	LD	(IX+2),A	;to buffer
	DEC	A		;for MSB
	LD	(IX+3),A	;MSB to buffer
	RET			;return ZERO
;
INCDE	INC	DE		;bump count
	RET
;
ZZZZZ	EQU	$
;
	END	VECTORS
